<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.payment.inc.php 0.16.1 2005/12/04 C K Wu

    class payment {

//---- Payment List SQL Formation

    function payment_list_sql() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	foreach ($ckapi['params_sql'] as $key => $value)	$$key = $value ;

	$last10 = substr($where,strlen($where)-10,10) ;
	$fields = "transdate,name,paynumber,remark,isocode,amount,a.id" ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$sql1 =	"SELECT $fields FROM ${pre}payment a, ${pre}vendor b WHERE 1=1 $where AND a.vendor=b.id " ;
		$sql2 =	"SELECT $fields FROM ${pre}payment a, ${pre}vendor b,${pre}p_match c " ;
		$sql2.=	"WHERE 1=1 $where AND vendor=b.id AND a.id=c.paymentid " ;
		$sql2.=	"GROUP BY $fields HAVING sum(s_amount)>=amount " ;
		if ($ckapi['hostsys']['dbtype']=="mysql")	{
			$user = $ckapi['hostsys']['username'] ;
			$ckapi['params_sql']['temp1'] = $temp1 = "${pre}pyl1".$user.time() ;
			$ckapi['params_sql']['temp2'] = $temp2 = "${pre}pyl2".$user.time() ;
			$adodb->query("CREATE TABLE $temp1 AS $sql1");
			$adodb->query("CREATE TABLE $temp2 AS $sql2");
			$sql = "SELECT $temp1.* from $temp1 LEFT JOIN $temp2 " ;
			$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL ORDER BY $order $sort" ;
			}
			else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
		}
	else	$sql =  "SELECT $fields FROM ${pre}payment a,${pre}vendor b WHERE 1=1 $where AND vendor=b.id ORDER BY $order $sort";
	return $sql ;
	}

//---- Payment Data Read

    function payment_read() {
	global $ckapi ;

	$op = $ckapi['params_post']['op'] ;
	$this->payment_header_read() ;
	if ($op<>'copy')			$this->payment_allotted_read() ;
	$this->payment_pending_read() ;
	$ckapi['params_post']['dt']['oldvendor'] = $ckapi['params_post']['dt']['vendor'] ;
	$ckapi['params_post']['dt']['oldisocode'] = $ckapi['params_post']['dt']['isocode'] ;
	$ckapi['params_post']['dt']['oldamount'] = $ckapi['params_post']['dt']['amount'] ;
	return $ckapi['params_post']['dt'] ;
	}

//---- Payment Data Header Read

    function payment_header_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$id = $ckapi['params_post']['id'] ;
	$dt = &$ckapi['params_post']['dt'] ;

	$result = $adodb->query("SELECT * FROM ${pre}payment WHERE id='$id'");
	$dt = $result->fetchRow() ;
	}

//---- Payment Data (Allotment) Read

    function payment_allotted_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$id = $ckapi['params_post']['id'] ;
	$dt = &$ckapi['params_post']['dt'] ;

	$sql = "SELECT invnumber,id,duedate,amount,s_amount FROM ${pre}ap, ${pre}p_match " ;
	$sql .= "WHERE paymentid='$id' and id=invoiceid and vendor='$dt[vendor]' and isocode='$dt[isocode]'";
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['pinvnumber'.$i]	=	$rs['invnumber'] ;
		$dt['pinvoiceid'.$i]	=	$rs['id'] ;
		$dt['pduedate'.$i]	=	$rs['duedate'] ;
		$dt['pinvoiceamt'.$i]	=	$rs['amount'] ;
		$dt['ps_amount'.$i]	=	$rs['s_amount'] ;
		$dt['pnewsamount'.$i]	=	"" ;
		}
	}

//---- Payment Data (Pending) Read

    function payment_pending_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$op = $ckapi['params_post']['op'] ;
	$id = isset($ckapi['params_post']['id']) ? $ckapi['params_post']['id'] : '' ;
	$dt = &$ckapi['params_post']['dt'] ;

	$user = $ckapi['hostsys']['username'];
	$temp1 = "${pre}py1".$user.time() ;
	$temp2 = "${pre}py2".$user.time() ;
	$format = '000000000000.00' ;
	if ($dt['vendor']=='')			$dt['vendor']=0 ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$sql.= "SELECT invnumber,id,duedate,amount,$format as s_amount,$format as paidamount " ;
	$sql.= "FROM ${pre}ap WHERE vendor='$dt[vendor]' and isocode='$dt[isocode]'";
	$adodb->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT invnumber,id,duedate,0.00 as amount,s_amount,0.00 as paidamount ";
	$sql.= "FROM ${pre}ap, ${pre}p_match WHERE id=invoiceid and paymentid='$id'";
	$adodb->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT invnumber,id,duedate,0.00 as amount,0.00 as s_amount,sum(s_amount) as paidamount " ;
	$sql.= "FROM ${pre}ap a, ${pre}p_match b ";
	$sql.= "WHERE vendor='$dt[vendor]' and a.id=b.invoiceid GROUP BY duedate,id,invnumber";
	$adodb->query($sql);
	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT invnumber,id,duedate,sum(amount) as amount," ;
	$sql.=		"sum(s_amount) as s_amount,sum(paidamount) as paidamt " ;
	$sql.= "FROM $temp1 GROUP BY duedate,id,invnumber ";
	$adodb->query($sql);
	$sql = "SELECT * FROM $temp2 WHERE amount > paidamt ORDER BY invnumber" ;
	$result = $adodb->query($sql) ;
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$upinvoiceamt		=	$rs['amount'] ;
		$uppaidamount		=	$rs['paidamt'] ;
		$dt['upinvnumber'.$i]	=	$rs['invnumber'] ;
		$dt['upinvoiceid'.$i]	=	$rs['id'] ;
		$dt['upduedate'.$i]	=	$rs['duedate'] ;
		$dt['upinvoiceamt'.$i]	=	$upinvoiceamt ;
		$s_amount = ($op=='add' or $op=='copy') ? 0 : $rs['s_amount'] ;
		$dt['ups_amount'.$i]	=	$s_amount ;
		$dt['ups_othamt'.$i]	=	$uppaidamount - $s_amount ;
		$dt['uppaidamount'.$i]	=	$uppaidamount ;
		$dt['uposamount'.$i]	=	$upinvoiceamt - $uppaidamount ;
		}
	$adodb->query("DROP TABLE $temp1, $temp2");
	}

//---- Payment Data Transformation

    function payment_transform() {
	global $ckapi ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['buttons'] as $key => $value)	$$key = $value ;
	$op = $ckapi['params_post']['op'] ;
	$id = isset($ckapi['params_post']['id']) ? $ckapi['params_post']['id'] : '';
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$vendor = $dt['vendor'] ;
	$oldvendor = $dt['oldvendor'] ;
	$isocode = $dt['isocode'] ;
	$oldisocode = $dt['oldisocode'] ;
	$amount = $dt['amount'] ;
	$oldamount = $dt['oldamount'] ;

	if ($vendor<>$oldvendor or $isocode<>$oldisocode) {
		$dt = "" ;
//		unset($dt) ;
		$dt['isocode'] = $isocode ;
		$dt['vendor'] = $vendor ;
		if ($op=='edit')	$this->payment_allotted_read() ;
		$this->payment_pending_read() ;
		if ($vendor<>$oldvendor and $oldvendor<>"") {
			$msg1 = exapi_lang("Vendor has been changed or newly picked") ;
			$msg2 = exapi_lang("All matchings start afresh");
			$t->set_var('message1',"<b>$msg1.  $msg2.</b>") ;
			}
		if ($isocode<>$oldisocode) {
			$msg1 = exapi_lang('Currency changed') ;
			$msg2 = exapi_lang('Default exchange rate loaded') ;
			$msg3 = exapi_lang('%1 invoices loaded',$isocode) ;
			$msg4 = exapi_lang('All matchings start afresh') ;
			$t->set_var('message1',"<b>$msg1.  $msg2.  $msg3.  $msg4.</b>");
			}
		unset($move, $match_equal, $match_fifo, $clear, $post) ;
		foreach ($ckapi['buttons'] as $key => $value)	$ckapi['buttons'][$key] = "" ;
		}
	if ($amount<>$oldamount) {
		$this->match_clear() ;
		$msg1 = exapi_lang("Payment amount has been changed") ;
		$msg2 = exapi_lang("All matchings start afresh") ;
		$t->set_var('message1',"<b>$msg1.  $msg2.</b>") ;
		unset($move, $match_equal, $match_fifo, $clear, $post) ;
		foreach ($ckapi['buttons'] as $key => $value)	$ckapi['buttons'][$key] = "" ;
		$dt['move'] = "" ;
		}
	if (isset($clear) and $clear<>'')		{$msg = $this->match_clear() ; $t->set_var('message1',$msg) ;}
	if (isset($match_equal) and $match_equal<>'')	{$msg = $this->match_equal() ; $t->set_var('message1',$msg) ;}
	if (isset($match_fifo) and $match_fifo<>'')	{$msg = $this->match_fifo() ; $t->set_var('message1',$msg) ;}
	}

//---- Payment Add Initialisation

    function payment_add_init() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = &$ckapi['params_post']['dt'] ;

	$dt['transdate'] = date("Y-m-d") ;
	$result = $adodb->query("SELECT nativecurr FROM ${pre}defaults");
	$dt['isocode'] = $dt['oldisocode'] = exapi_dbflds($result,'nativecurr') ;
	$dt['exrate'] = 1 ;
	$fields = array('id','control','vendor','oldvendor','amount','oldamount','payee','paynumber','transdate','remark','dr_accno_id','cr_accno_id') ;
	foreach ($fields as $field)	$dt[$field]='' ;
	$ckapi['params_post']['id'] = '' ;
	$this->payment_pending_read() ;
	}


//---- Payment Detail Validation Checks

    function payment_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang("Error") ;
	if ($dt['payee']=="")			$err=exapi_lang("Payee Missing");
	if ($dt['paynumber']=="")		$err=exapi_lang("Payment/Cheque Number Missing");
	if (input2date($dt['transdate'])=="")	$err=exapi_lang("Invalid Payment Date");
	if (!is_numeric($dt['amount']))		$err=exapi_lang("Payment amount must be numeric");
	if ($dt['exrate']<=0)			$err=exapi_lang("Invalid Exchange Rate") ;
	$result = $adodb->query("SELECT nativecurr FROM ${pre}defaults");
	if ($dt['isocode']==exapi_dbflds($result,'nativecurr') and $dt['exrate']<>1)
					$err=exapi_lang("Exchange rate for ledger currency must = 1") ;
	$result = $adodb->query("SELECT * FROM ${pre}currency WHERE isocode='$dt[isocode]'");
	$nativeexrate = exapi_dbflds($result,'exrate') ;
	if ($nativeexrate>0) {
		$ratio = $dt['exrate']/$nativeexrate ;
		if (0.8>$ratio or $ratio>1.2)	$err=exapi_lang("Exchange rate deviates too much from default") ;
		}
	$sum_pnewsamt = 0 ;
	$row = exapi_lang("Row") ; 
	For ($i=1;isset($dt['pinvoiceid'.$i]);$i++) {
		$pnewsamt = $dt['pnewsamount'.$i] ;
		$rowi = "[$row $i]" ;
		if ($pnewsamt<0)		$err=$rowi.exapi_lang("New Amount Settled must be +ve");
		if ($pnewsamt>$dt['amount']) $err=$rowi.exapi_lang("New Amount Settled > Payment Amount");
		if ($pnewsamt>$dt['pinvoiceamt'.$i])   $err=$rowi.exapi_lang("New Amount Settled > Invoice Amount");
		if (!is_numeric($pnewsamt) and strlen($pnewsamt)>0)
						$err=$rowi.exapi_lang("New Amount Settled must be numeric");
		$sum_pnewsamt += ($pnewsamt=="") ? $dt['ps_amount'.$i] : $pnewsamt ;
		}
	$sum_pnewsamt2 = sprintf("%01.2f",$sum_pnewsamt) ;
	$dt_amount2 = sprintf("%01.2f",$dt['amount']) ;
	if ($sum_pnewsamt2>$dt_amount2)		$err=exapi_lang("Total Amount Settled > Payment Amount");
	For ($i=1;isset($dt['upinvoiceid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		if ($dt['uposamount'.$i]<0)	$err=$rowi.exapi_lang("UNPAID invoice overpaid");
		}
	if ($dt['isocode']<>$dt['oldisocode']) {
		$warn1 = exapi_lang('Currency changed') ;
		$warn2 = exapi_lang('Default exchange rate loaded') ;
		$warn3 = exapi_lang('%1 invoices loaded',$dt['isocode']) ;
		$warn4 = exapi_lang('All matchings start afresh') ;
		$err = "$warn1;  $warn2;  $warn3;  $warn4" ;
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Payment Header

    function payment_header_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$result = $adodb->query("SELECT nativecurr FROM ${pre}defaults");
	$loc_for = (exapi_dbflds($result,'nativecurr')==$dt['isocode']) ? exapi_lang('Local') : exapi_lang('*** Foreign ***') ;
	if ($dt['isocode']<>$dt['oldisocode']) {
		$result = $adodb->query("SELECT exrate FROM ${pre}currency WHERE isocode='$dt[isocode]'");
		$dt['exrate'] = exapi_dbflds($result,'exrate') ;
		}
	$t->set_var('lang_vendor',exapi_lang('Vendor'));
	$t->set_var('lang_payee',exapi_lang('Payee'));
	$t->set_var('lang_paynumber',exapi_lang('Payment# / Cheque#'));
	$t->set_var('lang_id',exapi_lang('Audit ID').':');
	$t->set_var('lang_curr_payment',exapi_lang('Currency Payment'));
	$t->set_var('lang_loc_for',$loc_for);
	$t->set_var('lang_transdate',exapi_lang('Payment Date'));
	$t->set_var('lang_remark',exapi_lang('Remark'));
	$t->set_var('lang_amount',exapi_lang('Payment Amount'));
	$t->set_var('lang_drpostto',exapi_lang('Payment Amount Dr to Account'));
	$t->set_var('lang_crpostto',exapi_lang('Payment Amount Cr to Account'));
	$t->set_var('lang_isocode',exapi_lang('Currency'));
	$t->set_var('lang_exrate',exapi_lang('Exchange Rate'));
	$vendor = $dt['vendor'] ;
	$t->set_var('vendor',$vendor) ;
	$t->set_var('oldvendor',$vendor) ;
	$t->set_var('vendor_selectlist',selectlist('vendor','name','',$vendor,'id','name','id')) ;
	$t->set_var('payee',$dt['payee']) ;
	$t->set_var('paynumber',$dt['paynumber']) ;
	$t->set_var('id',$dt['id']) ;
	$t->set_var('control',$dt['control']) ;
	$t->set_var('transdate',$dt['transdate']) ;
	$t->set_var('remark',$dt['remark']) ;
	$t->set_var('amount',$dt['amount']) ;
	$t->set_var('oldamount',$dt['amount']) ;
$dr_acc_list = selectlist('chart','accno',"WHERE link like '%AP:%' or link like '%AP'",$dt['dr_accno_id'],'id','accno','substring(description,1,20)') ;
	$t->set_var('dr_acc_selectlist',$dr_acc_list) ;
	$cr_acc_list = selectlist('chart','accno',"WHERE link like '%AP_paid%'",$dt['cr_accno_id'],'id','accno','substring(description,1,20)') ;
	$t->set_var('cr_acc_selectlist',$cr_acc_list) ;
	$t->set_var('isocode_selectlist',selectlist('currency','isocode','',$dt['isocode'],'isocode','isocode','description')) ;
	$t->set_var('oldisocode',$dt['isocode']) ;
	$t->set_var('exrate',$dt['exrate']) ;
	$t->parse('out','report',True);
	}

//---- Write Payment Detail

    function payment_detail_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$op = $ckapi['params_post']['op'] ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$posted = ($op=="view" or $op=="delete") ;
	$t->set_block('report','paidlist','paidlist_section');
	$t->set_block('report','unpaidlist','unpaidlist_section');
	$moverow_ = exapi_lang('Move Row')." " ;
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	$t->set_var('lang_pltitle',exapi_lang('List of Fully/Partially PAID %1 Invoices settled by this Payment',$dt['isocode']));
	$t->set_var('lang_pinvnumber',exapi_lang('Invoice#'));
	$t->set_var('lang_pinvoiceid',exapi_lang('Invoice ID'));
	$t->set_var('lang_pduedate',exapi_lang('Due Date'));
	$t->set_var('lang_pfullamount',exapi_lang('Full Invoice Amount'));
	$t->set_var('lang_psettled',exapi_lang('Amount Settled<br>via this Payment'));
	$t->set_var('lang_pnewsamount',exapi_lang('Amount Settled via this<br>Payment to be Updated to'));
	$msgunderallo = exapi_lang('[Payment underallocated to Invoice]');
	$sum_pinvoiceamt = $sum_ps_amount = $sum_pnewsamt = 0 ;
	For ($i=1;isset($dt['pinvoiceid'.$i]);$i++) {
		$t->set_var('pinvnumber_fld','pinvnumber'.$i);
		$t->set_var('pinvoiceid_fld','pinvoiceid'.$i);
		$t->set_var('pduedate_fld','pduedate'.$i);
		$t->set_var('pinvoiceamt_fld','pinvoiceamt'.$i);
		$t->set_var('ps_amount_fld','ps_amount'.$i) ;
		$t->set_var('pnewsamount_fld','pnewsamount'.$i);
		$t->set_var('pinvnumber',$dt['pinvnumber'.$i]) ;
		$pinvoiceid = $dt['pinvoiceid'.$i] ;
		$t->set_var('pinvoiceid',$pinvoiceid) ;
		$t->set_var('pduedate',$dt['pduedate'.$i]) ;
		$t->set_var('pinvoiceamt',$dt['pinvoiceamt'.$i]) ;
		$t->set_var('ps_amount',$dt['ps_amount'.$i]) ;
		$pnewsamount = $dt['pnewsamount'.$i] ;
		if (is_numeric($pnewsamount))		$t->set_var('pnewsamount',"") ;
			else				$t->set_var('pnewsamount',$pnewsamount) ;
		if (strlen($pnewsamount)>0 and is_numeric($pnewsamount)) {
			For ($j=1;isset($dt['upinvoiceid'.$j]);$j++) {
				if ($pinvoiceid==$dt['upinvoiceid'.$j]) {
					$dt['ups_amount'.$j] = $pnewsamount ;
					$dt['uppaidamount'.$j]= $dt['ups_amount'.$j] + $dt['ups_othamt'.$j];
					$dt["uposamount$j"] = $dt["upinvoiceamt$j"] - $dt["uppaidamount$j"];
					break ;
					}
				}
			if (!isset($dt['upinvoiceid'.$j])) {
				$user = $ckapi['hostsys']['username'];
				$tmp = "${pre}pay".$user.time() ;
				$sql = "CREATE TABLE $tmp AS " ;
				$sql.=	"SELECT invnumber,id,duedate,amount,$format as s_amount,sum(s_amount) as paidamt " ;
				$sql.=	"FROM ${pre}ap,${pre}p_match " ;
				$sql.=	"WHERE id='$pinvoiceid' and invoiceid='$pinvoiceid' " ;
				$sql.=	"GROUP BY invnumber,id,duedate,amount" ;
				$adodb->query($sql);
				$sql = "INSERT INTO $tmp " ;
				$sql.=	"SELECT invnumber,id,duedate,amount,s_amount,0.00 as paidamt " ;
				$sql.=	"FROM ${pre}ap,${pre}p_match ";
				$sql.=	"WHERE id='$pinvoiceid' and " ;
				$sql.=		"invoiceid='$pinvoiceid' and paymentid='$dt[id]' " ;
				$adodb->query($sql);
				$sql = "SELECT invnumber,id,duedate,amount," ;
				$sql.=		"sum(s_amount) as s_amount,sum(paidamt) as paidamt " ;
				$sql.= "FROM $tmp GROUP BY invnumber,id,duedate,amount " ;
				$result = $adodb->query($sql) ;

				$dt['upinvnumber'.$j]	= exapi_dbflds($result,'invnumber') ;
				$dt['upinvoiceid'.$j]	= exapi_dbflds($result,'id') ;
				$dt['upduedate'.$j]	= exapi_dbflds($result,'duedate') ;
				$dt['upinvoiceamt'.$j]	= exapi_dbflds($result,'amount') ;
				$dt['ups_amount'.$j]	= $pnewsamount ;
				$dt['ups_othamt'.$j]	= exapi_dbflds($result,'paidamt')-exapi_dbflds($result,'s_amount');
				$dt['uppaidamount'.$j]	= $dt['ups_amount'.$j] + $dt['ups_othamt'.$j] ;
				$dt['uposamount'.$j]	= $dt['upinvoiceamt'.$j] - $dt['uppaidamount'.$j] ;
				$adodb->query("DROP TABLE $tmp");

				}
			$t->set_var('ps_amount',$pnewsamount) ;
			$dt['ps_amount'.$i] = $pnewsamount ;
			}
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('paidlist_section','paidlist', True);
		$sum_pinvoiceamt	+= $dt['pinvoiceamt'.$i] ;
		$sum_ps_amount		+= $dt['ps_amount'.$i] ;
		}
	if ($i==1)	$t->set_var('paidlist_section',"");
	$movrowno = isset($dt['move']) ? intval(str_replace($moverow_,'',$dt['move'])) : '' ;
	if ($movrowno<>0) {
		$t->set_var('pinvnumber_fld','pinvnumber'.$i);
		$t->set_var('pinvoiceid_fld','pinvoiceid'.$i);
		$t->set_var('pduedate_fld','pduedate'.$i);
		$t->set_var('pinvoiceamt_fld','pinvoiceamt'.$i);
		$t->set_var('ps_amount_fld','ps_amount'.$i) ;
		$t->set_var('pnewsamount_fld','pnewsamount'.$i);
		$t->set_var('pinvnumber',$dt['upinvnumber'.$movrowno]) ;
		$t->set_var('pinvoiceid',$dt['upinvoiceid'.$movrowno]) ;
		$t->set_var('pduedate',$dt['upduedate'.$movrowno]) ;
		$t->set_var('pinvoiceamt',$dt['upinvoiceamt'.$movrowno]) ;
		$t->set_var('ps_amount',0) ;
		$t->set_var('pnewsamount',"") ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('paidlist_section','paidlist', True);
		$sum_pinvoiceamt	+= $dt['upinvoiceamt'.$movrowno] ;
		}
	$msg = (isset($dt['amount']) and $dt['amount']>$sum_ps_amount) ? " <b>$msgunderallo</b>" : "" ;
	$t->set_var('lang_total',exapi_lang('Total Amount').$msg);
	$t->set_var('sum_pinvoiceamt',$sum_pinvoiceamt);
	$t->set_var('sum_ps_amount',$sum_ps_amount);
	$t->set_var('sum_pnewsamt',$sum_pnewsamt);
	$t->set_var('lang_upltitle',exapi_lang('List of Fully/Partially UNPAID %1 Invoices accrued on this vendor',$dt['isocode']));
	$t->set_var('lang_upinvnumber',exapi_lang('Invoice#'));
	$t->set_var('lang_upinvoiceid',exapi_lang('Invoice ID'));
	$t->set_var('lang_upduedate',exapi_lang('Due Date'));
	$t->set_var('lang_upfullamount',exapi_lang('Full Invoice Amount'));
	$t->set_var('lang_ups_amount',exapi_lang('Amount Settled via this Payment'));
	$t->set_var('lang_ups_othamt',exapi_lang('Amount Settled via other Payments'));
	$t->set_var('lang_uppaidamount',exapi_lang('Total Amount Settled'));
	$t->set_var('lang_uposamount',exapi_lang('Outstanding Unpaid Amount'));
	$t->set_var('lang_upmove2paid',exapi_lang('Move to Paid List'));
	For ($i=1;isset($dt['upinvoiceid'.$i]);$i++) {
		$t->set_var('upinvnumber_fld','upinvnumber'.$i);
		$t->set_var('upinvoiceid_fld','upinvoiceid'.$i);
		$t->set_var('upduedate_fld','upduedate'.$i);
		$t->set_var('upinvoiceamt_fld','upinvoiceamt'.$i);
		$t->set_var('ups_amount_fld','ups_amount'.$i);
		$t->set_var('ups_othamt_fld','ups_othamt'.$i);
		$t->set_var('uppaidamount_fld','uppaidamount'.$i) ;
		$t->set_var('uposamount_fld','uposamount'.$i);
		$t->set_var('upinvnumber',$dt['upinvnumber'.$i]) ;
		$t->set_var('upinvoiceid',$dt['upinvoiceid'.$i]) ;
		$t->set_var('upduedate',$dt['upduedate'.$i]) ;
		$t->set_var('upinvoiceamt',$dt['upinvoiceamt'.$i]) ;
		$t->set_var('ups_amount',$dt['ups_amount'.$i]) ;
		$t->set_var('ups_othamt',$dt['ups_othamt'.$i]) ;
		$t->set_var('uppaidamount',$dt['uppaidamount'.$i]) ;
		$t->set_var('uposamount',$dt['uposamount'.$i]) ;
		$t->set_var('rowno',$moverow_.$i) ;
		For ($j=1;isset($dt['pinvoiceid'.$j]);$j++) {
			if ($dt['upinvoiceid'.$i]==$dt['pinvoiceid'.$j])
				$t->set_var('rowno',exapi_lang("already in the list"));
			}
		if ($movrowno==$i)	$t->set_var('rowno',exapi_lang("already in the list")) ;
		if ($posted)		$t->set_var('rowno',"done") ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('unpaidlist_section','unpaidlist', True);
		}
	if ($i==1)	$t->set_var('unpaidlist_section',"");
	}

//---- Perform Payment/Invoice Matching on Balance Amount by Matching Equal Amount

    function match_equal() {
	global $ckapi ;

	$dt = &$ckapi['params_post']['dt'] ;

	if (!isset($dt['upinvoiceid1']))	$message1 = exapi_lang("All Invoices already settled") ;
	   else {
		$temp = $dt ;
		For ($j=1;isset($dt['upinvoiceid'.$j]);$j++)	$duedate[$j] = $temp['upduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$dt['upinvnumber'.$j]	=	$temp['upinvnumber'.$key] ;
			$dt['upinvoiceid'.$j]	=	$temp['upinvoiceid'.$key] ;
			$dt['upduedate'.$j]	=	$val ;
			$dt['upinvoiceamt'.$j]	=	$temp['upinvoiceamt'.$key] ;
			$dt['ups_amount'.$j]	=	$temp['ups_amount'.$key] ;
			$dt['ups_othamt'.$j]	=	$temp['ups_othamt'.$key] ;
			$dt['uppaidamount'.$j]	=	$temp['uppaidamount'.$key] ;
			$dt['uposamount'.$j]	=	$temp['uposamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $dt['amount'] ;
	For ($i=1;isset($dt['pinvoiceid'.$i]);$i++)	{
		$bal -= $dt['ps_amount'.$i] ;
		$dt['pnewsamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = exapi_lang("Payment is alreadly fully allocated.") ;
	   else {
		For ($j=1;isset($dt['upinvoiceid'.$j]);$j++) {
			if ($dt['uposamount'.$j]==$bal) {
				$dt['ups_amount'.$j] += $bal ;
				$dt['uppaidamount'.$j] += $bal ;
				$dt['uposamount'.$j]  = 0 ;
				$invoiceid = $dt['upinvoiceid'.$j] ;
				For ($i=1;isset($dt['pinvoiceid'.$i]);$i++) {
					if ($dt['pinvoiceid'.$i]==$invoiceid) {
						$dt['ps_amount'.$i] += $bal ;
						$dt['pnewsamount'.$i] = "" ;
						break ;
						}
					}
				if (!isset($dt['pinvoiceid'.$i])) {
					$dt['pinvnumber'.$i]	= $dt['upinvnumber'.$j] ;
					$dt['pinvoiceid'.$i]	= $dt['upinvoiceid'.$j] ;
					$dt['pduedate'.$i]	= $dt['upduedate'.$j] ;
					$dt['pinvoiceamt'.$i]	= $dt['upinvoiceamt'.$j];
					$dt['ps_amount'.$i]	= $bal ;
					$dt['pnewsamount'.$i]	= "" ;
					}
				break ;
				}
			}
		}
	if (isset($dt["upinvoiceid$j"]))
		$message3 = exapi_lang("Matching completed.  If result OK, click POST button to update.") ;
	$message = exapi_lang("No (equal) matching item found") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	if (isset($message3))		$message = $message3 ;
	return "<b>$message</b>" ;
	}

//---- Perform Payment/Invoice Matching on Balance Amount by FIFO Scheme

    function match_fifo() {
	global $ckapi ;

	$dt = &$ckapi['params_post']['dt'] ;

	if (!isset($dt['upinvoiceid1']))	$message1 = exapi_lang("All Invoices already settled") ;
	   else {
		$temp = $dt ;
		For ($j=1;isset($dt['upinvoiceid'.$j]);$j++)	$duedate[$j] = $temp['upduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$dt['upinvnumber'.$j]	=	$temp['upinvnumber'.$key] ;
			$dt['upinvoiceid'.$j]	=	$temp['upinvoiceid'.$key] ;
			$dt['upduedate'.$j]	=	$val ;
			$dt['upinvoiceamt'.$j]	=	$temp['upinvoiceamt'.$key] ;
			$dt['ups_amount'.$j]	=	$temp['ups_amount'.$key] ;
			$dt['ups_othamt'.$j]	=	$temp['ups_othamt'.$key] ;
			$dt['uppaidamount'.$j]	=	$temp['uppaidamount'.$key] ;
			$dt['uposamount'.$j]	=	$temp['uposamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $dt['amount'] ;
	For ($i=1;isset($dt['pinvoiceid'.$i]);$i++)	{
		$bal -= $dt['ps_amount'.$i] ;
		$dt['pnewsamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = exapi_lang("Payment is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($dt['upinvoiceid'.$j]);$j++) {
			$uposamt = $dt['uposamount'.$j] ;
			if ($uposamt>0) {
				if ($bal>=$uposamt) {
					$dt['ups_amount'.$j] += $uposamt ;
					$dt['uppaidamount'.$j] += $uposamt ;
					$dt['uposamount'.$j]  = 0 ;
					$invoiceid = $dt['upinvoiceid'.$j] ;
					For ($i=1;isset($dt['pinvoiceid'.$i]);$i++) {
						if ($dt['pinvoiceid'.$i]==$invoiceid) {
							$dt['ps_amount'.$i] += $uposamt ;
							$dt['pnewsamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($dt['pinvoiceid'.$i])) {
						$dt['pinvnumber'.$i]	= $dt['upinvnumber'.$j] ;
						$dt['pinvoiceid'.$i]	= $invoiceid ;
						$dt['pduedate'.$i]	= $dt['upduedate'.$j] ;
						$dt['pinvoiceamt'.$i]	= $dt['upinvoiceamt'.$j];
						if (isset($dt['ps_amount'.$i]))	$dt['ps_amount'.$i] += $uposamt ;
							else			$dt['ps_amount'.$i] = $uposamt ;
						$dt['pnewsamount'.$i]	= "" ;
						}
					$bal -= $uposamt ;
					}
				   else {
					$dt['ups_amount'.$j] += $bal ;
					$dt['uppaidamount'.$j] += $bal ;
					$dt['uposamount'.$j]  -= $bal ;
					$invoiceid = $dt['upinvoiceid'.$j] ;
					For ($i=1;(isset($dt['pinvoiceid'.$i]) and $bal>0);$i++) {
						if ($dt['pinvoiceid'.$i]==$invoiceid) {
							$dt['ps_amount'.$i] += $bal ;
							$dt['pnewsamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($dt['pinvoiceid'.$i])) {
						$dt['pinvnumber'.$i]	= $dt['upinvnumber'.$j] ;
						$dt['pinvoiceid'.$i]	= $invoiceid ;
						$dt['pduedate'.$i]	= $dt['upduedate'.$j] ;
						$dt['pinvoiceamt'.$i]	= $dt['upinvoiceamt'.$j];
						$dt['ps_amount'.$i]	= $bal ;
						$dt['pnewsamount'.$i]	= "" ;
						}
					$bal = 0 ;
					}
				}
			}
		}
	$message = exapi_lang("Matching completed.  If result OK, click POST button to update.") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	return "<b>$message</b>" ;
	}

//---- Clear current on-screen Payment/Invoice Matching

    function match_clear() {
	global $ckapi ;

	$dt = &$ckapi['params_post']['dt'] ;

	For ($i=1;isset($dt['pinvoiceid'.$i]);$i++)	{
		$invoiceid = $dt['pinvoiceid'.$i] ;
		$psamt = $dt['ps_amount'.$i] ;
		For ($j=1;isset($dt['upinvoiceid'.$j]);$j++) {
			if ($dt['upinvoiceid'.$j]==$invoiceid) {
				$dt['ups_amount'.$j] = 0 ;
				$dt['uppaidamount'.$j] -= $psamt ;
				$dt['uposamount'.$j]  += $psamt ;
				break ;
				}
			}
		if (!isset($dt['upinvoiceid'.$j])) {
			$dt['upinvnumber'.$j]	=	$dt['pinvnumber'.$i] ;
			$dt['upinvoiceid'.$j]	=	$invoiceid ;
			$dt['upduedate'.$j]	=	$dt['pduedate'.$i] ;
			$dt['upinvoiceamt'.$j]	=	$dt['pinvoiceamt'.$i] ;
			$dt['ups_amount'.$j]	=	0 ;
			$dt['ups_othamt'.$j]	=	$dt['pinvoiceamt'.$i] - $psamt ;
			$dt['uppaidamount'.$j]	=	$dt['ups_othamt'.$j] ;
			$dt['uposamount'.$j]	=	$psamt ;
			}
		unset($dt['pinvoiceid'.$i]) ;
		}
	$message = exapi_lang("All (on-screen) matchings for current Payment cleared.") ;
	return "<b>$message</b>" ;
	}

//---- Payment Post Initialisation

    function payment_post_init() {
	global $ckapi ;

	$tran = $ckapi['params']['tran'] ;
	$dt = &$ckapi['params_post']['dt'] ;

	$dt['cheque'] = '' ;
	$dt['source'] = "APPY" ;
	$dt['description'] = isset($dt['description']) ? $dt['description'] : "AP: Payment# $dt[paynumber]" ;
	}

//---- Payment Post - PreCommit Routine

    function payment_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = &$ckapi['params_post']['dt'] ;
	$id = &$ckapi['params_post']['id'] ;
	$op = &$ckapi['params_post']['op'] ;

	if (substr_count($ckapi['params_post']['script'],'acctran')>0)	{
		$adodb->query("DELETE from ${pre}acc_trans where trans_id='$id'");
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$chart_id	=	$dt['accno'.$i];
			$attrib1	=	$dt['attrib1'.$i] ;
			$attrib2	=	$dt['attrib2'.$i] ;
			$attrib3	=	$dt['attrib3'.$i] ;
			$dr		=	$dt['dr'.$i] ;
			$cr		=	$dt['cr'.$i] ;
			if ($dr==0) $amount=$cr; else $amount=-$dr;
			$attrib1 = ($attrib1=="") ? 0 : $attrib1 ;
			$attrib2 = ($attrib2=="") ? 0 : $attrib2 ;
			$attrib3 = ($attrib3=="") ? 0 : $attrib3 ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,attrib1,attrib2,attrib3,amount,transdate)" ;
			$sql.=	"VALUES ('$id','$chart_id','$attrib1','$attrib2','$attrib3','$amount','$dt[transdate]')" ;
			$adodb->query($sql);
			}
		return ;
		}
	if ($op<>'new')	{
		$adodb->query("DELETE from ${pre}acc_trans where trans_id='$id'");
		$adodb->query("DELETE from ${pre}p_match where paymentid=$id");
		}
	if ($op<>'delete') {
		$led_amount = number_format($dt['amount']*$dt['exrate'],2,".","") ;
		$sql1 = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) " ;
		$sql = "$sql1 VALUES('$id','$dt[dr_accno_id]','-$led_amount','$dt[transdate]')";
		$adodb->query($sql);
		$sql = "$sql1 VALUES('$id','$dt[cr_accno_id]','$led_amount','$dt[transdate]')";
		$adodb->query($sql);
		For ($i=1;isset($dt['pinvoiceid'.$i]);$i++) {
			$s_amt = $dt['pnewsamount'.$i]=="" ? $dt['ps_amount'.$i] : $dt['pnewsamount'.$i] ;
			if ($s_amt<>0) {
				$invid	= $dt['pinvoiceid'.$i] ;
				$sql = "INSERT INTO ${pre}p_match (paymentid,invoiceid,s_amount) " ;
				$sql.= "VALUES ('$id','$invid','$s_amt')";
				$adodb->query($sql);
				}
			}
		}
	}

//---- Payment Accounting Entries Reload (from payment tables)

    function payment_reload() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$id = $ckapi['params_post']['id'] ;

	$result = $adodb->query("SELECT * FROM ${pre}payment WHERE id='$id'") ;
	$payamt = number_format(exapi_dbflds($result,'amount')*exapi_dbflds($result,'exrate'),2,".","") ;
	$dt['accno1']	=	exapi_dbflds($result,'dr_accno_id') ;
	$dt['dr1']	= 	sprintf("%01.2f",$payamt) ;
	$dt['cr1']	= 	"" ;
	$dt['attrib11']	= 	"" ;
	$dt['attrib21']	= 	"" ;
	$dt['attrib31']	= 	"" ;
	$dt['accno2']	=	exapi_dbflds($result,'cr_accno_id') ;
	$dt['dr2']	= 	"" ;
	$dt['cr2']	= 	sprintf("%01.2f",$payamt) ;
	$dt['attrib12']	= 	"" ;
	$dt['attrib22']	= 	"" ;
	$dt['attrib32']	= 	"" ;
	return $dt;
	}

    }

?>
