<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.process.inc.php 0.16.1 2005/12/04 C K Wu

    class process {

//---- Process Filter

    function process_filter() {
	global $ckapi,$exapi,$exapidir ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;

	$search = isset($_GET['search']) ? $_GET['search'] : (isset($_POST['search']) ? $_POST['search'] :'') ;
	$err = isset($_GET['err']) ? $_GET['err'] : (isset($_POST['err']) ? $_POST['err'] :'') ;

	$t = exapi_tpl('ck-api');
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','select','select_section');
	$t->set_block('report','detail','detail_section');
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	
	$msg1 = exapi_lang('To search for all items, leave fields blank.') ;
	$msg2 = exapi_lang('Maximum length of search string is 15 characters.') ;
	$t->set_var('std_message',"$msg1  $msg2");

	foreach ($ckapi['phrases'] as $key => $value)	$t->set_var($key,$value) ;

	if ($err) {
		$t->set_var('lang_search_message',"<b>$err</b>") ;
		foreach ($ckapi['filter'] as $key => $row) {
			if (is_numeric($key)) {
				$varname = $row['varname'] ;
				$ckapi['filter'][$key]['defval'] = 
				  isset($_GET[$varname]) ? $_GET[$varname] : (isset($_POST[$varname])?$_POST[$varname]:'');
				}
			}
		}
	$detail = $select = False ;
	foreach ($ckapi['filter'] as $key => $row)	{
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->set_var('criteria',$row['criteria']);
		$t->set_var('varname',$row['varname']);
		$t->set_var('note',$row['note']);
		switch ($row['type'])	:
			case "input" :
				$t->set_var('defval',$row['defval']);
				$t->set_var('checkbox',"");
				$t->set_var('checked',"");
				$t->parse('detail_section','detail', True);
				$detail = True ;
				break ;
			case "checkbox" :
				$t->set_var('defval','yes');
				$t->set_var('checkbox',"type='checkbox'");
				$checked = ($row['defval']=='yes') ? "checked" : "" ;
				$t->set_var('checked',$checked);
				$t->parse('detail_section','detail', True);
				$detail = True ;
				break ;
			case "select" :
				$defval = $row['defval'] ;
				$sl = str_replace("'$defval'","'$defval' selected",$row['selectlist']) ;
				$t->set_var('selectlist',$sl);
				$t->parse('select_section','select', True);
				$select = True ;
				break ;
			endswitch ;
		}
	if (!$detail)	$t->set_var('detail_section','');
	if (!$select)	$t->set_var('select_section','');
	$t->parse('out','report',True);

	$getstr = isset($ckapi['filter']['getstr']) ? $ckapi['filter']['getstr'] : '' ;
	$act_script = isset($search_action) ? $search_action : "${tran}filter_validate.php" ;
	$t->set_var('search_action',exapi_link("/$app/$act_script",$getstr)) ;
	$act_script = isset($doneexit) ? $doneexit : "${tran}add.php" ;
	$t->set_var('add_action',exapi_link("/$app/$act_script")) ;
	$t->pparse('out','report',True);
	}
	
//---- Process Filter Validate

    function process_filter_validate() {
	global $ckapi,$exapi ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['sql_filter'] as $key => $val)
		if (!is_numeric($key))
			$$key = isset($_GET[$key]) ? $_GET[$key] : (isset($_POST[$key]) ? $_POST[$key] :'') ;
	
	$err='' ;  $error=exapi_lang('Error') ;  $markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;

	foreach ($ckapi['sql_filter'] as $key => $val) {
		if (is_numeric($key))			continue ;
		if ($$key=="")				continue ;
		if ($ckapi['sql_filter'][$key]['type']=='string') {
			if (strlen($$key)>15)		$err="[".$$key."]".exapi_lang("Search string too long") ;
			if (substr_count($$key,$markpri)>0)	
				$err="[".$$key."]".exapi_lang("Search string contains reserved pattern")." - $markpri";
			if (substr_count($$key,$marksec)>0)	
				$err="[".$$key."]".exapi_lang("Search string contains reserved pattern")." - $marksec";
			if (substr_count($$key," ")>0)	
				$err="[".$$key."]".exapi_lang("Search string should not contain space(s)");
			}
		if ($ckapi['sql_filter'][$key]['type']=='date') {
			$temp = input2date($$key) ;
			if ($temp=="")	$err="[".$$key."] - ".exapi_lang("Invalid date"); else $$key = $temp ;
			}
		if ($ckapi['sql_filter'][$key]['type']=='numeric') {
			if (!is_numeric($$key))			$err="[".$$key."] - ".exapi_lang("not a number");
			}
		}
	if ($err)						$err = "$error:  $err" ;

	if (!$err) {
		$filter = '' ;
		foreach ($ckapi['sql_filter'] as $key => $val) {
			if ($val['char']=="1") {
				if ($$key<>"ALL")	$filter.=$markpri.$val['char'].$val['str1'].$marksec.$$key;
				continue ;
				}
			if ($val['char']=="7") {
				if ($$key=="yes")	$filter.= $markpri.$val['char'] ;
				continue ;
				}
			if ($val['char']=="8") {
				if ($$key=="yes")	$filter.= $markpri.$val['char'].$val['str1'] ;
				continue ;
				}
			if (is_numeric($key) or $$key) {
							$filter.= $markpri.$val['char'].$val['str1'] ;
				if (substr_count("2,3,4,5,6",$val['char'])>0)	$filter.= $marksec.$$key ;
				}
			}
		$filter = urlencode($filter) ;
		Header('Location: '.exapi_link("/$app/${tran}list.php","filter=$filter"));
		exit();
		}
	  else	{
		$getstr = '' ;
		foreach ($ckapi['sql_filter'] as $key => $val)	if (!is_numeric($key))	$getstr.= "$key=".$$key."&";
		$getstr.= "err=$err" ;
		Header('Location: '.exapi_link("/$app/${tran}filter.php",$getstr));
		exit();
		}
	}

//---- Process Read

    function process_read() {
	global $ckapi,$exapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;
	$result = $adodb->query("SELECT * from $table WHERE id='$id'");
	if (isset($uniqueflds) and !is_array($uniqueflds) or $op<>'edit')    return $result->fetchRow() ;
	  else  {
		$dt = $result->fetchRow() ;
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
		return $dt ;
		}
	}

//---- Process List

    function process_list() {
	global $ckapi,$exapi,$exapidir,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter']) ? $_POST['filter'] :'');
	$order = isset($_GET['order']) ? $_GET['order'] : (isset($_POST['order']) ? $_POST['order'] :'');
	$sort = isset($_GET['sort']) ? $_GET['sort'] : (isset($_POST['sort']) ? $_POST['sort'] :'');
	$filter = urldecode(stripslashes($filter)) ;
	$where = $this->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$t = exapi_tpl($app);
	$t->set_file(array('report'=>"${tran}list.tpl", 'detail'=>"${tran}list.tpl"));
	$t->set_block('detail','detail_row','detail_section');
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;

	foreach ($ckapi['phrases'] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('lang_sorthead',exapi_lang('[click column heading to re-sort table]'));

	$script = "/$app/${tran}list.php" ;
	foreach ($ckapi['columns'] as $key => $value)	{$field1=$key; break;}
	$id = isset($id) ? $id : '' ;
	$getstr = "id=$id&filter=$filter" ;
	foreach ($ckapi['columns'] as $key => $value)
		$t->set_var("sort_${key}",$this->sortlink($value,$script,$key,$sort,$getstr));

	if (!$order)	{if (isset($sortkey))	$order=$sortkey;	else $order=$field1;}
	if (!$sort)	$sort = "ASC" ;

	$result= $adodb->query("SELECT * from $table WHERE $where order by $order $sort");
	if (exapi_dbrc($result)==0) {
		foreach ($ckapi['columns'] as $key => $value)	$t->set_var($key,"") ;
		$t->set_var("$field1",exapi_lang("No Matching Item Found")) ;
		$return = exapi_link("/$app/${tran}filter.php") ;
		$t->set_var(array(	'view'	=> $return,
					'edit'	=> $return,
					'copy'	=> $return,
					'delete'=> $return,
					'log'	=> $return  ));
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail_row',True);
		}
	while ($dt = $result->fetchRow()) {
		$id = $dt['id'] ;
		$getstr = "id=$id&filter=$filter" ;
		$loggetstr = "return=/$app/${tran}list.php&$getstr" ;
		foreach ($ckapi['columns'] as $key => $value)	$t->set_var($key,$dt[$key]) ;
		$t->set_var(array(	'view'	=> exapi_link("/$app/${tran}view.php",$getstr),
					'edit'	=> exapi_link("/$app/${tran}edit.php",$getstr),
					'copy'	=> exapi_link("/$app/${tran}copy.php",$getstr),
					'delete'=> exapi_link("/$app/${tran}delete.php",$getstr),
					'log'	=> exapi_link('/ck-admin/loglist.php',$loggetstr) 	));
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail_row',true);
		}

	$t->set_var('add_action',exapi_link("/$app/${tran}add.php",$getstr));
	$t->set_var('lang_edit',exapi_lang('Edit'));
	$t->set_var('lang_view',exapi_lang('View'));
	$t->set_var('lang_copy',exapi_lang('Copy/Modify'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_log',exapi_lang('Log'));
	$t->pparse('out','detail','report');
	}

//---- Process View

    function process_view() {
	global $ckapi,$exapi,$exapidir ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['phrases'] as $key => $value)	$$key = $value ;
	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$filter=stripslashes($filter);

	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi['phrases'] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','');

	$ckapi['params_post']['id'] = $id ;
	$ckapi['params_post']['posted'] = True ;
	$ckapi['params_post']['dt'] = $this->process_read() ;
	$ckapi['objects']['template'] = &$t ;
	$func = $tran."_write" ;	$tranobj->$func() ;

	$getstr = "filter=$filter" ;
	$t->set_var('action',exapi_link("/$app/${tran}list.php",$getstr)) ;
	$t->set_var('lang_post',exapi_lang('Done'));
	$t->set_var('done_action',exapi_link("/$app/${tran}list.php",$getstr)) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report', True );
	}

//---- Process Add

    function process_add() {
	global $ckapi,$exapi,$exapidir ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['phrases'] as $key => $value)	$$key = $value ;

	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$post = isset($_GET['post']) ? $_GET['post'] : (isset($_POST['post'])?$_POST['post']:'');
	$filter=stripslashes($filter);

	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi['phrases'] as $key => $value)	$t->set_var($key,$value) ;

	$ckapi['params_post']['dt'] = $_POST ;
	$ckapi['objects']['template'] = &$t ;
	$func = $tran."_write" ;	$tranobj->$func() ;

	if ($post<>'') {
		$func = $tran."_validate" ;
		$err = $tranobj->$func() ;
		$t->set_var('message',$err) ;
		if ($err=='') {
			$this->process_post();
			$posted = True ;
			}
		}

	$getstr="filter=$filter";
	$return = ($filter=="") ? "${tran}filter.php" : "${tran}list.php" ;
	if (isset($posted)) {
		$t->set_var('action',exapi_link("/$app/$return",$getstr));
		$t->set_var('lang_post',exapi_lang('Done'));
		$t->set_var('readonly','readonly') ;
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',exapi_link("/$app/${tran}add.php",$getstr)) ;
		$t->set_var('lang_post',$lang_post);
		$t->set_var('readonly','') ;
		$t->set_var('disabled','');
		}
	$t->set_var('done_action',exapi_link("/$app/$return",$getstr));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Process Copy

    function process_copy() {
	global $ckapi,$exapi,$exapidir ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['phrases'] as $key => $value)	$$key = $value ;
	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$post = isset($_GET['post']) ? $_GET['post'] : (isset($_POST['post'])?$_POST['post']:'');
	$filter=stripslashes($filter);

	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi['phrases'] as $key => $value)	$t->set_var($key,$value) ;

	if ($post=='') {
		$ckapi['params_post']['id'] = $id ;
		$_POST=$this->process_read();
		$_POST['id']="";
		}
	$ckapi['params_post']['dt'] = $_POST ;
	$ckapi['objects']['template'] = &$t ;
	$func = $tran."_write" ;	$tranobj->$func() ;

	if ($post<>'') {
		$func = $tran."_validate" ;
		$err = $tranobj->$func() ;
		$t->set_var('message',$err) ;
		if ($err=='') {
			$this->process_post();
			$posted = True ;
			}
		}

	$getstr = "filter=$filter";
	if (isset($posted)) {
		$t->set_var('action',exapi_link("/$app/${tran}list.php",$getstr));
		$t->set_var('lang_post',exapi_lang('Done'));
		$t->set_var('readonly','readonly') ;
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',exapi_link("/$app/${tran}copy.php",$getstr)) ;
		$t->set_var('lang_post',$lang_post);
		$t->set_var('readonly','') ;
		$t->set_var('disabled','');
		}
	$t->set_var('done_action',exapi_link("/$app/${tran}list.php",$getstr));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Process Edit

    function process_edit() {
	global $ckapi,$exapi,$exapidir ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['phrases'] as $key => $value)	$$key = $value ;
	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$post = isset($_GET['post']) ? $_GET['post'] : (isset($_POST['post'])?$_POST['post']:'');
	$filter=stripslashes($filter);

	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi['phrases'] as $key => $value)	$t->set_var($key,$value) ;

	if ($post=='') {
		$ckapi['params_post']['id'] = $id ;
		$_POST=$this->process_read();
		}
	$ckapi['params_post']['dt'] = $_POST ;
	$ckapi['objects']['template'] = &$t ;
	$func = $tran."_write" ;	$tranobj->$func() ;

	if ($post<>'') {
		$func = $tran."_validate" ;
		$err = $tranobj->$func() ;
		$t->set_var('message',$err) ;
		if ($err=='') {
			$err=$this->process_post();
			if ($err<>"")	$t->set_var('message',$err) ;
				else	$posted = True ;
			}
		}

	$getstr="filter=$filter";
	if (isset($posted)) {
		$t->set_var('action',exapi_link("/$app/${tran}list.php",$getstr));
		$t->set_var('lang_post',exapi_lang('Done'));
		$t->set_var('readonly','readonly') ;
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',exapi_link("/$app/${tran}edit.php",$getstr)) ;
		$t->set_var('lang_post',$lang_post);
		$t->set_var('readonly','') ;
		$t->set_var('disabled','');
		}
	$t->set_var('done_action',exapi_link("/$app/${tran}list.php",$getstr));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report',True);
	}

    function process_delete() {
	global $ckapi,$exapi,$exapidir ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['phrases'] as $key => $value)	$$key = $value ;
	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$control = isset($_GET['control']) ? $_GET['control'] : (isset($_POST['control'])?$_POST['control']:'');
	$yes = isset($_GET['yes']) ? $_GET['yes'] : (isset($_POST['yes'])?$_POST['yes']:'');
	$filter=stripslashes($filter);

	$tranobj = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$t->set_file('question','confirm.tpl');
	$t->set_file('report',"${tran}screen.tpl") ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_confirm',exapi_lang('Are you sure you want to delete ?'));
	foreach ($ckapi['phrases'] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('msg','') ;
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

	$ckapi['params_post']['id'] = $id ;
	$ckapi['params_post']['posted'] = True ;
	$_POST=$this->process_read();
	$ckapi['params_post']['dt'] = $_POST ;
	$ckapi['objects']['template'] = &$t ;
	$func = $tran."_write" ;	$tranobj->$func() ;

	if ($yes=='') 	$control = $_POST['control'] ;
	  else	{
		$_POST['id'] = $id ;
		$_POST['control'] = $control ;
		$err = $this->delete_validate() ;
		if ($err=="")	if (method_exists($tranobj,"delete_validate"))	$err=$tranobj->delete_validate();
		if ($err<>'')	{$yes=''; $t->set_var('lang_title',"$lang_title => $err");}
		}
	$getstr="filter=$filter&control=$control";
	if ($yes=='') {
		$t->set_var('lang_yes',exapi_lang('Yes'));
		$t->set_var('lang_no',exapi_lang('No'));
		$getstr .= "&id=$id" ;
		$t->set_var('yes_action', exapi_link("/$app/${tran}delete.php",$getstr));
		$t->set_var('no_action',exapi_link("/$app/${tran}list.php",$getstr)) ;
		$t->pparse('out','question',True);
		}
	   else {
		$err=$this->process_post();
//		$err=$this->process_post($params,$phrases,$_POST, $t);
		$t->set_var('lang_yes',exapi_lang('done'));
		$t->set_var('lang_no',exapi_lang('done'));
		$t->set_var('yes_action',exapi_link("/$app/${tran}list.php",$getstr)) ;
		$t->set_var('no_action',exapi_link("/$app/${tran}list.php",$getstr)) ;
		$t->pparse('out','question',True);
		if ($err<>'')	$t->set_var('lang_title',"$lang_title => $err");
		}

	$t->set_var('action',exapi_link("/$app/${tran}list.php",$getstr));
	$t->set_var('lang_post',exapi_lang('Done'));
	$t->set_var('done_action',exapi_link("/$app/${tran}list.php",$getstr));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Process Post (posting data to db table)

    function process_post() {
	global $ckapi,$exapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['phrases'] as $key => $value)	$$key = $value ;

	$db_type = $ckapi['hostsys']['dbtype'] ;
	if ($op=="copy" or $op=="add")	$op=$ckapi['params_post']['op']="new" ;
	$id = (isset($dt['id']) and $dt['id']<>'') ? $dt['id'] : 0 ;
//	$id = ($dt['id']=="") ? 0 : $dt['id'] ;
	$ip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
	$user = $ckapi['hostsys']['username'];
	$now = mktime() ;
	$iptime = "$ip=$now=$script=$id" ;

	if ($op<>"new") {
		$err=""; $error=exapi_lang('Error') ;
		$lang_deleted = exapi_lang("was deleted while your request was processed") ;
		$lang_modified= exapi_lang("was modified while your request was processed") ;
		$lang_restart = exapi_lang("Please exit current screen and restart action if necessary");
		$result = $adodb->query("SELECT control FROM $table WHERE id = '$id'");
		if (exapi_dbrc($result)==0)
			$err = "<b>$error: $tran [id#$id]: $lang_deleted.  $lang_restart.</b>";
		if ($dt['control'] < exapi_dbflds($result,'control'))
			$err = "<b>$error: $tran [id#$id]: $lang_modified.  $lang_restart.</b>" ;
		if ($err)	return $err ;
		$control = $dt['control'] + 1 ;
		}

	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$adodb->query($sql);
	$sql = "INSERT INTO ${pre}log (trans_id,app,script,ip,userid,op,timestamp,iptime) " ;
	$sql.= "VALUES ('$id','$app','$script','$ip','$user','$op','$now','$iptime')" ;
	$adodb->query($sql);
	$result= $adodb->query("SELECT id from ${pre}log WHERE iptime='$iptime'");
	$logid = exapi_dbflds($result,'id');

	switch ($op) :
		case "new" :
			$id = $logid ;
			$sql = "SELECT a.attname as Field, format_type(a.atttypid,a.atttypmod) " ;
			$sql.= "FROM pg_class c,pg_attribute a ";
			$sql.= "WHERE c.relname='$table' and a.attnum>0 and a.attrelid=c.oid" ;
			if ($db_type=="mysql")		$sql = "describe $table" ;
			$result= $adodb->query($sql);
			$fields = $values = "" ;
			While ($rs = $result->fetchRow()) {
				$fldname = (isset($rs['Field'])) ? $rs['Field'] : $rs['field'] ;
				if ($fldname<>'control' and $fldname<>'id') {
					$val = addslashes($dt[$fldname]) ;
					$fields.="$fldname," ;
					$values.="'$val'," ;
					}
				}
			$adodb->query("INSERT INTO $table ($fields id) VALUES ($values '$id')");
			$ckapi['params_post']['id'] = $id ;
			$ckapi['params_post']['logid'] = $logid ;
			$this->update_log_header() ;
			$type = exapi_lang("New") ;
			$actioned = exapi_lang("added") ;
			break ;
		case "edit" :
			$sql = "SELECT a.attname as Field, format_type(a.atttypid,a.atttypmod) " ;
			$sql.= "FROM pg_class c,pg_attribute a ";
			$sql.= "WHERE c.relname='$table' and a.attnum>0 and a.attrelid=c.oid" ;
			if ($db_type=="mysql")		$sql = "describe $table" ;
			$result = $adodb->query($sql);
			$fields = "" ;
			While ($rs = $result->fetchRow()) {
				$fldname = (isset($rs['Field'])) ? $rs['Field'] : $rs['field'] ;
				$val = addslashes($dt[$fldname]) ;
				if ($fldname<>'control')	$fields.="$fldname='$val'," ;
				}
			$adodb->query("UPDATE $table SET $fields control='$control' WHERE id='$id'");
			$ckapi['params_post']['id'] = $id ;
			$ckapi['params_post']['logid'] = $logid ;
			$this->update_log_header() ;
			$type = exapi_lang("Old") ;
			$actioned = exapi_lang("updated") ;
			break ;
		case "delete" :
			$ckapi['params_post']['id'] = $id ;
			$ckapi['params_post']['logid'] = $logid ;
			$this->update_log_header() ;
			$adodb->query("DELETE from $table where id = $id");
			$type = exapi_lang("Old") ;
			$actioned = exapi_lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$adodb->query($sql);
	$t = &$ckapi['objects']['template'] ;
	$reminder = isset($reminder) ? $reminder : '' ;
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$t->set_var("message","<b>$type $lang_tran [id#$id] $actioned.  $reminder</b>") ;
	$t->set_var('lang_confirm',"<b>$type $lang_tran [id#$id] $actioned.</b>");
	return isset($err) ? $err : '' ;
	}

//---- Update Log Header

    function update_log_header() {
	global $ckapi,$exapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;
	$result = $adodb->query("SELECT * FROM $table WHERE id = '$id'");
	$headerarr[$table] = $result->fetchRow() ;
	$header = addslashes(serialize($headerarr));
	$fields = "header='$header'" ;
	if ($op=="new")	$fields="trans_id=id,$fields" ;
	$adodb->query("UPDATE ${pre}log SET $fields WHERE id='$logid'");
	}

//---- Standard Delete Validation Checks

    function delete_validate() {
	global $ckapi,$exapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;
	$err=""; $error=exapi_lang('Error') ;
	$errmsg1 = exapi_lang("This item is in use within an existing") ;
	$journal = exapi_lang("journal") ;
	$id = $dt['id'] ;
	$result = $adodb->query("SELECT attrib1tbl,attrib2tbl,attrib3tbl from ${pre}defaults");
	$a1tbl = exapi_dbflds($result,'attrib1tbl') ;
	$a2tbl = exapi_dbflds($result,'attrib2tbl') ;
	$a3tbl = exapi_dbflds($result,'attrib3tbl') ;
	if ($a1tbl == $table) {
		$result = $adodb->query("SELECT * from ${pre}acc_trans WHERE attrib1='$id'");
		if (exapi_dbrc($result)>0)
			$err = "$errmsg1 $journal id#".exapi_dbflds($result,'trans_id') ;
		}
	if ($a2tbl == $table) {
		$result = $adodb->query("SELECT * from ${pre}acc_trans WHERE attrib2='$id'");
		if (exapi_dbrc($result)>0)
			$err = "$errmsg1 $journal id#".exapi_dbflds($result,'trans_id') ;
		}
	if ($a3tbl == $table) {
		$result = $adodb->query("SELECT * from ${pre}acc_trans WHERE attrib3='$id'");
		if (exapi_dbrc($result)>0)
			$err = "$errmsg1 $journal id#".exapi_dbflds($result,'trans_id') ;
		}
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Decode 'where' filter string

    function decode_where($filter) {
	global $ckapi,$exapi ;

	if (trim($filter)<>"") {
		$markpri = $ckapi['params']['markpri'] = "zzAnDzz" ;
		$marksec = $ckapi['params']['marksec'] = "z2z1z3z" ;	
		$where = '' ;
		$pieces = explode($markpri,$filter) ;
		foreach ($pieces as $piece) {
			if (trim($piece)=="")			continue ; 

			$str = explode($marksec,$piece) ;
			$str1 = $str[0] ;
			$str2 = isset($str[1]) ? $str[1] : '' ;
//			echo "99-$str1..$str2==<br>" ; die() ;
//			list($str1,$str2) = explode($marksec,$piece) ;

			$type = substr($str1,0,1) ;
			$str1 = substr($str1,1) ;
			if (strlen($str1)>15 or strlen($str2)>15) {
				echo "Please inform System Admin: Possible (type 1) injected SQL attack -$piece==<br>";
				exit() ;
				}	
			if (substr_count($piece," ")>0) {
				echo "Please inform System Admin: Possible (type 2) injected SQL attack -$piece==<br>";
				exit() ;
				}
			switch ($type) :
				case "0" :	$where .= "$str1 $str2" ;		break ;
				case "1" :	$where .= " AND $str1 = '$str2' " ;	break ;
				case "2" :	$where .= " AND $str1 >= '$str2' ";	break ;
				case "3" :	$where .= " AND $str1 > '$str2' ";	break ;
				case "4" :	$where .= " AND $str1 <= '$str2' ";	break ;
				case "5" :	$where .= " AND $str1 < '$str2' ";	break ;
				case "6" :	$where .= " AND lower($str1) like lower('%$str2%') ";  break;
				case "7" :	$where .= " AND OPEN " ;		break ;
				case "8" :	$where .= " AND $str1" ;		break ;
				case "9" :	$where .= " AND position($str1 in $str2)>0" ;		break ;
				endswitch ;
			}
		}
	return isset($where) ? $where : '' ;
	}

//---- Generate sort link string

    function sortlink($title,$script,$order,$sort,$getstr='') {
	global $exapi ;

	$sort = ($sort=='ASC') ? 'DESC' : 'ASC' ;
	$getstr = ($getstr<>'') ? "order=$order&sort=$sort&$getstr" : "order=$order&sort=$sort" ;
	$linkage = exapi_link($script,$getstr) ;
	$link = "<a href='$linkage'>$title</a>";
	return $link ;
	}

    }

?>
