<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.csnt.inc.php 0.16.1 2005/12/04 C K Wu

    class csnt {

//---- Cash Sale List SQL Formation

    function csnt_list_sql() {
	global $ckapi ;

	$pre = $ckapi['params']['pre'] ;
	foreach ($ckapi['params_sql'] as $key => $value)	$$key = $value ;

	$sql =  "SELECT transdate,a.shift as shift,b.name as cashbox," ;
	$sql.=		"posnumber,a.cashier as cashier,amount,a.id as id " ;
	$sql.=  "FROM ${pre}pos a, ${pre}cashbox b " ;
	$sql.=	"WHERE amount=netamount $where AND a.cboxid=b.id ORDER BY $order $sort" ;
	return $sql ;
	}

//---- Cash Sale Data Read

    function csnt_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$id = $ckapi['params_post']['id'] ;
	$op = $ckapi['params_post']['op'] ;
	$script = $ckapi['params_post']['script'] ;

	$result = $adodb->query("SELECT * FROM ${pre}pos WHERE id='$id'");
	$dt = $result->fetchRow() ;
	if ($op=='add' or $op=='copy') {
		$dt['cashier'] = $ckapi['hostsys']['username'];
		$dt['cboxid'] = $dt['shift'] = '' ;
		$dt['posnumber'] = exapi_lang("[to be assigned]") ;
		}

	$sql = "SELECT * FROM ${pre}positem " ;
	$sql.= "WHERE trans_id='$id' and (itemtype='i' or itemtype='s') ORDER BY id" ;
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['csitemid'.$i]	=	$rs['itemid'] ;
		$dt['csitemtype'.$i]	=	$rs['itemtype'] ;
		$dt['csqty'.$i]		=	$rs['qty'] ;
		$dt['csunit'.$i]	=	$rs['unit'] ;
		$dt['csprice'.$i]	=	$rs['price'] ;
		$dt['csdiscount'.$i]	=	$rs['discount'] ;
		}
	$result = $adodb->query("SELECT * FROM ${pre}positem WHERE trans_id='$id' and itemtype='a' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++)	$dt['aoitemid'.$i] = $rs['itemid'] ;

	$result = $adodb->query("SELECT * FROM ${pre}positem WHERE trans_id='$id' and itemtype='q' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['qcitemid'.$i]	=	$rs['itemid'] ;
		$dt['qcqty'.$i]		=	$rs['qty'] ;
		$dt['qcvalue'.$i]	=	$rs['value'] ;
		}
	return $dt ;
	}

//---- Cash Sale Add Initialisation

    function csnt_add_init() {
	global $ckapi,$pre,$adodb ;

	$dt = &$ckapi['params_post']['dt'] ;
	$dt['transdate'] = date("Y-m-d") ;
	$dt['cashier'] = $ckapi['hostsys']['username'];
	$dt['posnumber'] = exapi_lang("[to be assigned]") ;
	$result = $adodb->query("SELECT id FROM ${pre}customer WHERE name='____Cash'");
	$dt['customer'] = exapi_dbflds($result,'id') ;
	$fields = array('id','control','shift','cboxid') ;
	foreach ($fields as $field)	$dt[$field]='' ;
	}

//---- Cash Sale Detail Validation Checks

    function csnt_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$err = "";
	$csrow = exapi_lang("csRow") ;
	$cserr = exapi_lang("csError:") ;
	if (input2date($dt['transdate'])=="")	$err="$cserr ".exapi_lang('Invalid Cash Sale Date');
	For ($i=1;isset($dt['csitemid'.$i]);$i++) {
		$csrowi = "[$csrow $i]" ;
		if ($dt['csitemid'.$i]=='')	$err="$csrowi$cserr ".exapi_lang('Item Code Missing');
		if ($dt['csqty'.$i] and !is_numeric($dt['csqty'.$i]))
					$err="$csrowi$cserr ".exapi_lang("Invalid Qty, must be numeric");
		if ($dt['csdiscount'.$i] and !is_numeric($dt['csdiscount'.$i]))
				$err="$csrowi$cserr ".exapi_lang("Invalid Discount, must be numeric");
		}
	$cstotal = $dt['cstotal'] ;
	$cserrstatus = $err ;
	$aorow = exapi_lang("aoRow") ;
	$aoerr = exapi_lang("aoError:") ;
	For ($i=1;isset($dt['aoitemid'.$i]);$i++) {
		$aorowi = "[$aorow $i]" ;
		if ($dt['aoitemid'.$i]=='')	$err="$aorowi$aoerr ".exapi_lang("Item Code Missing");
		  else	{
			$aoitemid = $dt['aoitemid'.$i] ;
			$result = $adodb->query("SELECT * FROM ${pre}addon WHERE id='$aoitemid'");
			if (exapi_dbrc($result)>0) {
				$mincount = exapi_dbflds($result,"mincount") ;
				$maxcount = exapi_dbflds($result,"maxcount") ;
				$minsale = exapi_dbflds($result,"minsale") ;
				$maxsale = exapi_dbflds($result,"maxsale") ;
				}
			$count = 0 ;
			For ($j=1;isset($dt['aoitemid'.$j]);$j++) {
				if ($dt['aoitemid'.$j]==$aoitemid)	$count++ ;
				}
			if ($count<$mincount)	$err="$aoerr ".exapi_lang("Item count < Min count for").$aorowi ;
			if ($count>$maxcount)	$err="$aoerr ".exapi_lang("Item count > Max count for").$aorowi ;
			if ($cstotal<$minsale)	$err="$aoerr ".exapi_lang("Total Cash Sale < Min sale for").$aorowi;
			if ($cstotal>$maxsale)	$err="$aoerr ".exapi_lang("Total Cash Sale > Max sale for").$aorowi;
			}
		}
	if ($i==2 and $dt['aoitemid1']=='')		$err = $cserrstatus ;
	$qcrow = exapi_lang("qcRow") ;
	$qcerr = exapi_lang("qcError:") ;
	For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
		$qcrowi = "[$qcrow $i]" ;
		if ($dt['qcitemid'.$i]=='')	$err="$qcrowi$qcerr ".exapi_lang("Item Code Missing");
		  else	{
			if ($dt['qcqty'.$i] and !is_numeric($dt['qcqty'.$i]))
					$err="$qcrowi$qcerr ".exapi_lang("Invalid Qty, must be numeric");
			if ($dt['qcvalue'.$i] and !is_numeric($dt['qcvalue'.$i]))
				$err="$qcrowi$qcerr ".exapi_lang("Invalid Value, must be numeric");
			$qcitemid = $dt['qcitemid'.$i] ;
			$result = $adodb->query("SELECT * FROM ${pre}qcash WHERE id='$qcitemid'");
			if (exapi_dbrc($result)>0) {
				$minsale = exapi_dbflds($result,"minsale") ;
				$maxsale = exapi_dbflds($result,"maxsale") ;
				$minqty = exapi_dbflds($result,"minqty") ;
				$maxqty = exapi_dbflds($result,"maxqty") ;
				$minvalue = exapi_dbflds($result,"minvalue") ;
				$maxvalue = exapi_dbflds($result,"maxvalue") ;
				}
			$qty = $value = 0 ;
			For ($j=1;isset($dt['qcitemid'.$j]);$j++) {
				if ($dt['qcitemid'.$j]==$qcitemid) {
					$qty += $dt['qcqty'.$j] ;
					$value += $dt['qcvalue'.$j] ;
					}
				}
			if ($qty<$minqty)	$err="$qcerr ".exapi_lang("Total item qty < Min qty for").$qcrowi ;
			if ($qty>$maxqty)	$err="$qcerr ".exapi_lang("Total item qty > Max qty for").$qcrowi ;
			if ($value<$minvalue) $err="$qcerr ".exapi_lang("Total item value < Min value for").$qcrowi;
			if ($value>$maxvalue) $err="$qcerr ".exapi_lang("Total item value > Max value for").$qcrowi;
			if ($cstotal<$minsale)	$err="$qcerr ".exapi_lang("Total Cash Sale < Min sale for").$qcrowi;
			if ($cstotal>$maxsale)	$err="$qcerr ".exapi_lang("Total Cash Sale > Max sale for").$qcrowi;
			}
		}
	if ($dt['totqc']<$dt['totpay'])	$err="$qcerr ".exapi_lang("Total Tendered < Total Payable") ;
	if ($dt['cboxid']=="")		$err="$cserr ".exapi_lang('Cashier with no Cash Box assigned');
	if (!$err and $dt['cboxid']<>"")	{
		$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
		$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='s'" ;
		$result = $adodb->query($sql) ;
		if (exapi_dbrc($result)<=0)
			$err="$cserr ".exapi_lang("Cashbox start-of-shift action pending") ;
		$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
		$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='e'" ;
		$result = $adodb->query($sql) ;
		if (exapi_dbrc($result)>0)
			$err="$cserr ".exapi_lang("Cashbox closed (end-of-shift completed)") ;
		  else	{
			$result = $adodb->query("SELECT * FROM ${pre}cashbox where id='$dt[cboxid]'") ;
			$maxcash = exapi_dbflds($result,'maxcash') ;
			$cashbal = $this->cashbalance($dt['cboxid'],$dt['transdate'],$dt['shift']) ;
			$warning = exapi_lang("Warning:") ;
			if ($cashbal>=$maxcash)	$err="$warning ".exapi_lang("Cash Full Level reached") ;
			}
		}
	If ($err)	$err = "<b><font size='+2'>$err</font></b>" ;
	if (substr_count($err,exapi_lang("csError:"))>0)	$t->set_var('csmessage',$err);
	if (substr_count($err,exapi_lang("Warning:"))>0)	{$t->set_var('csmessage',$err); $err="";}
	if (substr_count($err,exapi_lang("aoError:"))>0)	$t->set_var('aomessage',$err);
	if (substr_count($err,exapi_lang("qcError:"))>0)	$t->set_var('qcmessage',$err);

	return $err ;
	}

//---- Cash Sale Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang('Error') ;
	$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
	$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='e'" ;
	$result = $adodb->query($sql) ;
	if (exapi_dbrc($result)>0)
		$err="$cserr ".exapi_lang("Cashbox closed (end-of-shift completed)") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Cash Sale Header

    function csnt_header_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;
	$script = &$ckapi['params_post']['script'] ;
	$t = &$ckapi['objects']['template'] ;

	$taxstatus = "e" ;
	$t->set_var('lang_posnumber',exapi_lang('Cash Sale#'));
	$t->set_var('lang_id',exapi_lang('Audit ID').': ');
	$t->set_var('lang_cashier',exapi_lang('Cashier:')." ");
	$t->set_var('lang_cashbox',exapi_lang('Cash Box'));
	$t->set_var('lang_transdate',exapi_lang('Date'));
	$t->set_var('lang_shift',exapi_lang('Shift'));
	$t->set_var('lang_customer',exapi_lang('Customer'));
	$t->set_var('lang_taxstatus',exapi_lang('UP Tax Status'));
	$t->set_var('posnumber',$dt['posnumber']) ;
	$cashier = $dt['cashier'] ;
	$transdate = $dt['transdate'] ;
	$shift = $dt['shift'] ;
	$customer = $dt['customer'] ;
	$cboxid = $dt['cboxid'] ;
	$sql = ($cboxid) ? "SELECT * FROM ${pre}cashbox WHERE id='$cboxid'" :
				"SELECT * FROM ${pre}cashbox WHERE cashier='$cashier'" ;
	$result = $adodb->query($sql) ;
	$t->set_var('cashbox',exapi_dbflds($result,'name')) ;
	if (!$cboxid)	$cboxid = exapi_dbflds($result,'id') ;
	if (!$shift)	$shift = exapi_dbflds($result,'shift') ;
	if ($shift=="1")		$shift_desc = "1 - Morning" ;
	if ($shift=="2")		$shift_desc = "2 - Afternoon" ;
	if ($shift=="3")		$shift_desc = "3 - Overnight" ;
	$t->set_var('id',$dt['id']) ;
	$t->set_var('control',$dt['control']) ;
	$t->set_var('cashier',$cashier) ;
	$t->set_var('transdate',$transdate) ;
	$t->set_var('shift',$shift) ;
	$t->set_var('shift_desc',$shift_desc) ;
	$t->set_var('cboxid',$cboxid) ;
	$t->set_var('customer',$customer) ;
	$t->set_var('customer_selectlist',selectlist('customer','name','',$customer,'id','name','id')) ;
	$tax_sl = "<OPTION value='e' selected>".exapi_lang('Tax Exempted')."</OPTION>" ;
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->parse('out','report',True);
	}

//---- Reformat Cash Sales Array

    function csnt_transform() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['buttons'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;

	$csrow_ = exapi_lang('csRow')." " ;
	$cashsale = exapi_lang('Cash Sale') ;
	$temp['id'] = $dt['id'] ;
	$temp['control'] = $dt['control'] ;
	$temp['cashier'] = $dt['cashier'] ;
	$temp['posnumber'] = $dt['posnumber'] ;
	$temp['transdate'] = $dt['transdate'] ;
	$temp['shift'] = $dt['shift'] ;
	$temp['cboxid'] = $dt['cboxid'] ;
	$temp['customer'] = $dt['customer'] ;
	$temp['taxstatus'] = "e" ;

	if (isset($delete)) {$delrowno = intval(str_replace($csrow_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($dt['csitemid'.$i]);$i++) {
		$csitemid = $dt['csitemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($csitemid<0)	{
			$csitemid = -$csitemid ;
			$csqty = $dt['csqty'.$i]==0 ? 1 : $dt['csqty'.$i] ;
			$result = $adodb->query("SELECT * FROM ${pre}assembly WHERE assembly_id='$csitemid'");
			While ($rs=$result->fetchRow()) {
				$temp['csitemid'.$j] = $rs['item_id'] ;
				$temp['csqty'.$j] = $rs['qty'] * $csqty ;
				$j++ ;
				}
			continue ;
			}
		$temp['csitemid'.$j]		=	$dt['csitemid'.$i] ;
		$temp['csqty'.$j]		=	$dt['csqty'.$i] ;
		$temp['csprice'.$j]		=	isset($dt['csprice'.$i]) ? $dt['csprice'.$i] : '' ;
		$temp['csdiscount'.$j]		=	$dt['csdiscount'.$i] ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$cashsale ;
	if (substr_count($newrow,$cashsale)>0)	{
		$fields = array('csitemid','csitemtype','csunit','csqty','csprice','csdiscount') ;
		foreach ($fields as $field)	$temp[$field.$j] = '' ;
		}

	For ($i=1;isset($dt['aoitemid'.$i]);$i++)	$temp['aoitemid'.$i]=$dt['aoitemid'.$i] ;

	For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
		$temp['qcitemid'.$i]		=	$dt['qcitemid'.$i] ;
		$temp['qcqty'.$i]		=	$dt['qcqty'.$i] ;
		$temp['qcvalue'.$i]		=	$dt['qcvalue'.$i] ;
		}

	$dt = $temp ;
	unset($temp) ;
	}

//---- Write Cash Sale Detail

    function csnt_detail_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$firstime = isset($ckapi['params_post']['firstime']) ? $ckapi['params_post']['firstime'] : '' ;
	$op = $ckapi['params_post']['op'] ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$csrow_ = exapi_lang('csRow')." " ;
	$cashsale = exapi_lang('Cash Sale') ;
	$taxstatus = "e" ;
	if ($op=="view" or $op=="delete")	$posted = True ;
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	$t->set_var('lang_csale',exapi_lang('Cash Sale Items :'));
	$t->set_var('lang_number',exapi_lang('Item Code - Id'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_qty',exapi_lang('Qty'));
	$t->set_var('lang_unit',exapi_lang('Unit'));
	$t->set_var('lang_discount',exapi_lang('Discount')."<br>$");
	$t->set_var('lang_price',exapi_lang('Unit Price'));
	$t->set_var('lang_itemtotal',exapi_lang('Item Total'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_csnewrow',exapi_lang('Add New')." $cashsale ".exapi_lang('Item Row'));
	$item_sl = item_selectlist("",'') ;

	$cstotal = 0 ;
	For ($i=1;isset($dt['csitemid'.$i]);$i++) {
		$t->set_var('itemid_fld','csitemid'.$i) ;
		$t->set_var('qty_fld','csqty'.$i);
		$t->set_var('discount_fld','csdiscount'.$i);
		$csitemid = $dt['csitemid'.$i] ;
		$t->set_var('csitemid',$csitemid) ;
		$t->set_var('item_selectlist',str_replace("'$csitemid'","'$csitemid'"." selected",$item_sl));
		$csqty = ($csitemid<>'' and $dt['csqty'.$i]=='') ? 1 : $dt['csqty'.$i] ;
		$csdiscount = $dt['csdiscount'.$i] ;
		$csprice = $dt['csprice'.$i] ;
		unset($itemid) ;
		$csitemid = ($csitemid=="") ? 0 : $csitemid ;
		$result = $adodb->query("SELECT * FROM ${pre}sprice WHERE id='$csitemid'") ;
		if (exapi_dbrc($result)>0) {
			$itemid = $dt['itemid'.$i] = exapi_dbflds($result,'itemid') ;
			$name = exapi_dbflds($result,'name') ;
			$price = exapi_dbflds($result,'price') ;
			}
		$item_id = isset($itemid) ? $itemid : $csitemid ;
		$result = $adodb->query("SELECT * FROM ${pre}service WHERE id='$item_id'") ;
		if (exapi_dbrc($result)>0) {
			$type = "s" ;
			$desc = exapi_dbflds($result,'description') ;
			$unit = exapi_dbflds($result,'unit') ;
			$dt['csincaccid'.$i] =  exapi_dbflds($result,'income_accno_id') ;
			if (!isset($itemid))	$price = exapi_dbflds($result,'price') ;
			}
		     else {
			$result = $adodb->query("SELECT * FROM ${pre}parts WHERE id='$item_id'");
			$type = "i" ;
			$desc = exapi_dbflds($result,'description') ;
			$unit = exapi_dbflds($result,'unit') ;
			$dt['cscost'.$i] = exapi_dbflds($result,'cost') ;
			$dt['csinvaccid'.$i] =  exapi_dbflds($result,'inventory_accno_id') ;
			$dt['csincaccid'.$i] =  exapi_dbflds($result,'income_accno_id') ;
			$dt['csexpaccid'.$i] =  exapi_dbflds($result,'expense_accno_id') ;
			if (!isset($itemid))	$price = exapi_dbflds($result,'price') ;
			}
		$description = isset($itemid) ? $name." -- Special -- ".$desc : $desc ;
		$csitemtype = $dt['csitemtype'.$i] = $type;
		$csunit = $dt['csunit'.$i] = $unit ;
		$csprice = $dt['csprice'.$i] = $price ;
		$t->set_var('itemtype',$csitemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$csunit);
		$t->set_var('qty',$csqty);
		$t->set_var('discount',$csdiscount);
		$t->set_var('price',$csprice);
		$itemtotal = $dt['csitemtotal'.$i] = number_format($csqty*$csprice-$csdiscount,2,".",'') ;
		$cstotal += $itemtotal ;
		$t->set_var('itemtotal',$itemtotal);
		$t->set_var('rowno',$csrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);

		$dt['csitemid'.$i] = $csitemid ;
		$dt['csitemtype'.$i] = $csitemtype ;
		$dt['csqty'.$i] = $csqty ;
		$dt['csprice'.$i] = $csprice ;
		$dt['csdiscount'.$i] = $csdiscount ;
		$dt['csunit'.$i] = $csunit ;
		}

	$t->set_var('lang_cstotal',exapi_lang('Total Cash Sale'));
	$dt['cstotal'] = number_format($cstotal,2,".",'') ;
	$t->set_var('cstotal',$dt['cstotal']) ;
	$this->csnt_addon_write();
	$this->csnt_qcash_write();
	}

//---- Write Cash Sale AddOn Items

    function csnt_addon_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['buttons'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_block('report','addon','addon_section');
	$op = isset($op) ? $op : '' ;
	if ($op=="view" or $op=="delete")	$posted = True ;
	$aorow_ = exapi_lang('aoRow')." " ;
	$addon = exapi_lang('AddOn') ;
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	$t->set_var('lang_addon',exapi_lang('Add On Charge/Reduction Items :'));
	$t->set_var('lang_addonnumber',exapi_lang('AddOn Name - Id'));
	$t->set_var('lang_notes',exapi_lang('Notes'));
	$t->set_var('lang_factor',exapi_lang('% of CS'));
	$t->set_var('lang_aoamount',exapi_lang('Amount'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_aonewrow',exapi_lang('Add New')." $addon ".exapi_lang('Item Row'));
	if (isset($delete))	$delrowno = intval(str_replace($aorow_,"",$delete));
	if ($delrowno==0)	unset($delete) ;
	$today = date('Y-m-d') ;
	$addon_sl = "<OPTION value=''></OPTION>".selectlist('addon','name',"WHERE start<='$today' and endd>='$today'",'','id','name','id') ;
	$totpay = $cstotal = $dt['cstotal'] ;
	For ($i=1;isset($dt['aoitemid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if (isset($delete) and $i>$delrowno) {$j=$i-1;} else {$j=$i;}
		$t->set_var('itemid_fld','aoitemid'.$j) ;
		$itemid = $dt['aoitemid'.$i] ;
		$t->set_var('itemid',$itemid) ;
		$t->set_var('addon_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$addon_sl));
		$itemid = ($itemid=="") ? 0 : $itemid ;
		$result = $adodb->query("SELECT * FROM ${pre}addon WHERE id='$itemid'") ;
		$notes = exapi_dbflds($result,'notes') ;
		$pos = strpos($notes,"--log--") ;
		$notes = ($pos=="" and substr($notes,0,7)<>"--log--") ? $notes : substr($notes,0,$pos) ;
		$factor = $dt['aofactor'.$i] = exapi_dbflds($result,'factor') ;
		$dt['aoincaccid'.$i] = exapi_dbflds($result,'incacc_id') ;
		$dt['aoexpaccid'.$i] = exapi_dbflds($result,'expacc_id') ;
		$aoamount = $dt['aoamount'.$i] = number_format($cstotal*$factor,2,".",'') ;
		$t->set_var('notes',$notes);
		$t->set_var('factor',$factor*100);
		$t->set_var('aoamount',$aoamount);
		$totpay += $aoamount ;
		$t->set_var('rowno',$aorow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('addon_section','addon', True);
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$addon ;
	if (substr_count($newrow,$addon)>0) {
		$t->set_var('itemid_fld','aoitemid'.$i) ;
		$t->set_var('addon_selectlist',$addon_sl);
		$t->set_var('notes',"");
		$t->set_var('factor',"");
		$t->set_var('aoamount',"");
		$t->set_var('rowno',$aorow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('addon_section','addon', True);
		}
	$t->set_var('lang_totpay',exapi_lang('Total Payable'));
	$t->set_var('totpay',number_format($totpay,2,".",'')) ;
	$dt['totpay'] = $totpay ;
	}

//---- Write Cash Sale Payment / Quasi Cash Items

    function csnt_qcash_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['buttons'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_block('report','qcash','qcash_section');
	$op = isset($op) ? $op : '' ;
	if ($op=="view" or $op=="delete")	$posted = True ;
	$qcrow_ = exapi_lang('qcRow')." " ;
	$qcash = exapi_lang('QCash') ;
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	$t->set_var('lang_qcash',exapi_lang('Payment / Quasi-Cash Tendered :'));
	$t->set_var('lang_qcashnumber',exapi_lang('QCash Name - Id'));
	$t->set_var('lang_notes',exapi_lang('Notes'));
	$t->set_var('lang_qty',exapi_lang('Qty'));
	$t->set_var('lang_value',exapi_lang('Value'));
	$t->set_var('lang_qcamount',exapi_lang('Amount'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_qcnewrow',exapi_lang('Add New')." $qcash ".exapi_lang('Row'));
	if (isset($delete))	$delrowno = intval(str_replace($qcrow_,"",$delete));
	if ($delrowno==0)	unset($delete) ;
	$today = date('Y-m-d') ;
	$qcash_sl = "<OPTION value=''></OPTION>".selectlist('qcash','name',"WHERE start<='$today' and endd>='$today'",'','id','name','id') ;
	$totpay = $dt['totpay'] ;
	$totqc = 0 ;
	For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if (isset($delete) and $i>$delrowno) {$j=$i-1;} else {$j=$i;}
		$t->set_var('itemid_fld','qcitemid'.$j) ;
		$t->set_var('qty_fld','qcqty'.$j);
		$t->set_var('value_fld','qcvalue'.$j);
		$itemid = $dt['qcitemid'.$i] ;
		$t->set_var('itemid',$itemid) ;
		$t->set_var('qcash_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$qcash_sl));
		$itemid = ($itemid=="") ? 0 : $itemid ;
		$result = $adodb->query("SELECT * FROM ${pre}qcash WHERE id='$itemid'") ;
		$notes = exapi_dbflds($result,'notes') ;
		$pos = strpos($notes,"--log--") ;
		$notes = ($pos=="" and substr($notes,0,7)<>"--log--") ? $notes : substr($notes,0,$pos) ;
		$dt['qcposaccid'.$i] = exapi_dbflds($result,'posacc_id') ;
		$qcqty = $dt['qcqty'.$i]<>'' ? $dt['qcqty'.$i]: 1;
		$faceval = exapi_dbflds($result,'value') ;
		$value = $dt['qcvalue'.$i] = ($faceval<>'' and $faceval<>0) ? $faceval : $dt['qcvalue'.$i] ;
		$qcamount = $dt['qcamount'.$i] = number_format($qcqty*$value,2,".",'') ;
		$t->set_var('notes',$notes);
		$t->set_var('qty',$qcqty);
		$t->set_var('value',$value);
		$t->set_var('qcamount',$qcamount);
		$totqc += $qcamount ;
		$t->set_var('rowno',$qcrow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('qcash_section','qcash', True);
		}

	$lasti = $i-1 ;
	$dt['qcqty'.$lasti] = isset($qcqty) ? $qcqty : '' ;

	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$qcash ;
	if (substr_count($newrow,$qcash)>0) {
		$t->set_var('itemid_fld','qcitemid'.$i) ;
		$t->set_var('qcash_selectlist',$qcash_sl);
		$t->set_var('qty_fld','qcqty'.$i);
		$t->set_var('value_fld','qcvalue'.$i);
		$t->set_var('notes',"");
		$t->set_var('qty',"");
		$t->set_var('value',"");
		$t->set_var('qcamount',"");
		$t->set_var('rowno',$qcrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('qcash_section','qcash', True);
		}
	$t->set_var('lang_totqc',exapi_lang('Total'));
	$t->set_var('totqc',number_format($totqc,2,".",'')) ;
	$t->set_var('lang_change',exapi_lang('Change'));
	$dt['totqc'] = $totqc ;
	$qcchange = $dt['qcchange'] = number_format($totqc-$totpay,2,".",'') ;
	$t->set_var('change',$qcchange) ;
	$lang_cash = exapi_lang('Cash') ;
	$result = $adodb->query("SELECT * FROM ${pre}qcash WHERE name='$lang_cash'") ;
	$dt['cashaccid'] = exapi_dbflds($result,'posacc_id') ;
	}

//---- Cash Sale Post Initialisation

    function csnt_post_init() {
	global $ckapi ;

	$dt = &$ckapi['params_post']['dt'] ;
	$op = &$ckapi['params_post']['op'] ;

	$user = $ckapi['hostsys']['username'];
	$dt['posnumber'] = ($op=='edit') ? $dt['posnumber'] : "$user:".date("Ymd:His") ;
	$dt['taxincluded']	= 'e' ;
	$dt['source']	= "CSNT" ;
	$desc = exapi_lang('Cash Sale') ;
	$dt['description'] = "CS: $desc# $dt[posnumber]" ;
	$dt['amount'] = $dt['netamount'] = $dt['totpay'] ;
	}

//---- Cash Sale Post - PreCommit Routine

    function csnt_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$op = $ckapi['params_post']['op'] ;
	$id = $ckapi['params_post']['id'] ;
	$dt = $ckapi['params_post']['dt'] ;
	$transdate = $dt['transdate'] ;

	if ($op<>'new')	{
		$adodb->query("DELETE from ${pre}positem where trans_id=$id");
		$adodb->query("DELETE from ${pre}acc_trans where trans_id=$id");
		$adodb->query("DELETE from ${pre}il where id=$id");
		$adodb->query("DELETE from ${pre}inv_trans where trans_id=$id");
		}

	if ($op<>'delete') {
		$invitem = False ;
		For ($i=1;isset($dt['csitemid'.$i]);$i++) {
			$csitemid	= $dt['csitemid'.$i];
			$csitemtype	= $dt['csitemtype'.$i];
			$csunit		= $dt['csunit'.$i];
			$csqty		= $dt['csqty'.$i];
			$csprice	= $dt['csprice'.$i];
			$csdiscount	= $dt['csdiscount'.$i];
			$itemtotal	= $dt['csitemtotal'.$i] ;
			$cost		= isset($dt['cscost'.$i]) ? $dt['cscost'.$i] : '' ;
			$invaccid	= isset($dt['csinvaccid'.$i]) ? $dt['csinvaccid'.$i] : '' ;
			$incaccid	= $dt['csincaccid'.$i] ;
			$expaccid	= isset($dt['csexpaccid'.$i]) ? $dt['csexpaccid'.$i] : '' ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$incaccid','$itemtotal','$transdate')";
			$adodb->query($sql);
			if ($csitemtype=="i" and $cost<>0 and $cost<>'') {
				$cogs = number_format($csqty*$cost,2,".",'') ;
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$expaccid','-$cogs','$transdate')";
				$adodb->query($sql);
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$invaccid','$cogs','$transdate')";
				$adodb->query($sql);
				$sql="INSERT INTO ${pre}inv_trans (trans_id,order_id,parts_id,qty,transdate)";
				$sql.= " VALUES ('$id','$id','$csitemid','-$csqty','$transdate')" ;
				$adodb->query($sql);
				$invitem = True ;
				}
			$invaccid = ($invaccid=="") ? 0 : $invaccid ;
			$incaccid = ($incaccid=="") ? 0 : $incaccid ;
			$expaccid = ($expaccid=="") ? 0 : $expaccid ;
			$sql = "INSERT INTO ${pre}positem (trans_id,invacc_id,incacc_id,expacc_id,itemid," ;
			$sql.= "itemtype,qty,price,cost,discount,unit) " ;
			$sql.= "VALUES ('$id','$invaccid','$incaccid','$expaccid','$csitemid'," ;
			$sql.= "'$csitemtype','$csqty','$csprice','$cost','$csdiscount','$csunit')";
			$adodb->query($sql);
			}
		if ($invitem == True) {
			$ildesc1 = exapi_lang('GD against CS') ;
			$ildesc = "CS: $ildesc1# $dt[posnumber]" ;
			$sql = "INSERT INTO ${pre}il (id,source,description,to_from,transdate) " ;
			$sql.= "VALUES ('$id','$dt[source]','$ildesc','$dt[customer]','$transdate') " ;
			$adodb->query($sql) ;
			}
		For ($i=1;isset($dt['aoitemid'.$i]);$i++) {
			$aoitemid = $dt['aoitemid'.$i] ;
			if ($aoitemid=="")	continue ;
			$aofactor = $dt['aofactor'.$i] ;
			$aoamount = $dt['aoamount'.$i] ;
			$aoincaccid = $dt['aoincaccid'.$i] ;
			$aoexpaccid = $dt['aoexpaccid'.$i] ;
			$chartid = ($aoamount>0) ? $aoincaccid : $aoexpaccid ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$chartid','$aoamount','$transdate')";
			$adodb->query($sql);
			$sql = "INSERT INTO ${pre}positem (trans_id,incacc_id,expacc_id," ;
			$sql.= "itemid,itemtype,value,factor) " ;
			$sql.= "VALUES ('$id','$aoincaccid','$aoexpaccid'," ;
			$sql.= "'$aoitemid','a','$dt[cstotal]','$aofactor')";
			$adodb->query($sql);
			}
		For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
			$qcitemid = $dt['qcitemid'.$i] ;
			$qcqty = $dt['qcqty'.$i] ;
			$qcvalue = $dt['qcvalue'.$i] ;
			$qcamount = $dt['qcamount'.$i] ;
			$qcposaccid = $dt['qcposaccid'.$i] ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$qcposaccid','-$qcamount','$transdate')";
			$adodb->query($sql);
			$sql = "INSERT INTO ${pre}positem(trans_id,posacc_id,itemid,itemtype,qty,value) ";
			$sql.= "VALUES ('$id','$qcposaccid','$qcitemid','q','$qcqty','$qcvalue')";
			$adodb->query($sql);
			}
		if ($dt['qcchange']<>0) {
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$dt[cashaccid]','$dt[qcchange]','$transdate')";
			$adodb->query($sql);
			$sql = "INSERT INTO ${pre}positem(trans_id,posacc_id,itemid,itemtype,qty,value) ";
			$sql.= "VALUES ('$id','$dt[cashaccid]',0,'c','1','-$dt[qcchange]')" ;
			$adodb->query($sql);
			}
		}
	}

//---- Calculate Cash Box Cash Balance

    function cashbalance($cboxid,$transdate,$shift) {
	global $adodb,$pre ;

	$sql =	"SELECT sum(qty*a.value) as amount FROM ${pre}positem a, ${pre}pos b, ${pre}qcash c " ;
	$sql.=	"WHERE cboxid='$cboxid' and transdate='$transdate' and shift='$shift' and " ;
	$sql.=		"name='Cash' and a.trans_id=b.id and a.itemid=c.id GROUP BY itemid" ;
	$result = $adodb->query($sql);
	$amount = exapi_dbflds($result,'amount');
	$sql =	"SELECT sum(qty*value) as amount FROM ${pre}positem a, ${pre}pos b " ;
	$sql.=	"WHERE cboxid='$cboxid' and transdate='$transdate' and shift='$shift' and " ;
	$sql.=		"itemtype='c' and a.trans_id=b.id GROUP BY itemid" ;
	$result = $adodb->query($sql);
	$amount+= exapi_dbflds($result,'amount');
	$sql =	"SELECT sum(amount) as amount from ${pre}cbtran " ;
	$sql.=	"WHERE cboxid='$cboxid' and transdate='$transdate' and shift='$shift'" ;
	$result = $adodb->query($sql);
	$amount+= exapi_dbflds($result,'amount');

	return $amount ;
	}
	
    }

?>