<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.qcash.inc.php 0.16.1 2005/12/04 C K Wu

    class qcash {

//---- Qcash Detail Validation Checks

    function qcash_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$table = $ckapi['params']['table'] ;
	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang('Error') ;
	if (!$dt['name'] or $dt['name']=="")		$err=exapi_lang('Quasi-Cash Name missing');
		else	{
			$result = $adodb->query("SELECT * from $table WHERE name='$dt[name]'") ;
			if (exapi_dbrc($result)<>0 and $dt['name']<>$dt['oldname'])
				$err=exapi_lang('Quasi-Cash name already in use');
			}
	if ($dt['minsale']>$dt['maxsale'])			$err=exapi_lang('Min sale must be <= Max sale');
	if ($dt['minqty']>$dt['maxqty'])			$err=exapi_lang('Min qty must be <= Max qty');
	if ($dt['minvalue']>$dt['maxvalue'])			$err=exapi_lang('Min value must be <= Max value');
	if ($dt['value'] and !is_numeric($dt['value']))		$err=exapi_lang("Face value must be numeric");
	if ($dt['minsale'] and !is_numeric($dt['minsale']))	$err=exapi_lang("Min cash sale must be numeric");
	if ($dt['maxsale'] and !is_numeric($dt['maxsale']))	$err=exapi_lang("Max cash sale must be numeric");
	if ($dt['minqty'] and !is_numeric($dt['minqty']))	$err=exapi_lang("Min qty must be numeric");
	if ($dt['maxqty'] and !is_numeric($dt['maxqty']))	$err=exapi_lang("Max qty must be numeric");
	if ($dt['minvalue'] and !is_numeric($dt['minvalue']))	$err=exapi_lang("Min value must be numeric");
	if ($dt['maxvalue'] and !is_numeric($dt['maxvalue']))	$err=exapi_lang("Max value must be numeric");
	if (input2date($dt['start'])=="")			$err=exapi_lang('Invalid [Valid from] Date');
	if (input2date($dt['endd'])=="")			$err=exapi_lang('Invalid [Valid to] Date');
	if (strtotime($dt['start'])>strtotime($dt['endd']))	$err=exapi_lang('[Valid from] LaterThan [Valid to]');
	if (strtotime($dt['start'])=="-1") 			$err=exapi_lang("[Valid from] beyond valid date range");
	if (strtotime($dt['endd'])=="-1")			$err=exapi_lang("[Valid to] beyond valid date range");
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Qcash Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang('Error') ;
	$cashsale = exapi_lang('cash sale') ;
	$errmsg1 = exapi_lang("This quasi-cash is in use within an existing") ;
	$id = $dt['id'] ;
	$result = $adodb->query("SELECT * from ${pre}positem WHERE itemid='$id'");
	if (exapi_dbrc($result)>0)	$err = "$errmsg1 $cashsale id#".exapi_dbflds($result,'id') ;

	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Qcash Detail

    function qcash_write() {
	global $ckapi ;

	$t = &$ckapi['objects']['template'] ;

	$t->set_var('lang_id',exapi_lang('Audit ID').': ');
	$t->set_var('lang_splan_id',exapi_lang('Sales Promotion Plan ID:')."  ");
	$t->set_var('lang_name',exapi_lang('Name'));
	$t->set_var('lang_value',exapi_lang('Nominal Face Value'));
	$t->set_var('lang_minsale',exapi_lang('Min Cash Sale'));
	$t->set_var('lang_maxsale',exapi_lang('Max Cash Sale'));
	$t->set_var('lang_minqty',exapi_lang('Min Qty per Tran'));
	$t->set_var('lang_maxqty',exapi_lang('Max Qty per Tran'));
	$t->set_var('lang_minvalue',exapi_lang('Min ($)value per Tran'));
	$t->set_var('lang_maxvalue',exapi_lang('Max ($)value per Tran'));
	$t->set_var('lang_start',exapi_lang('Valid from:'));
	$t->set_var('lang_endd',exapi_lang('Valid to:'));
	$t->set_var('lang_notes',exapi_lang('Notes'));
	$t->set_var('lang_linkageaccount',exapi_lang("Link to Ledger Accounts"));
	$t->set_var('lang_pos_accno',exapi_lang("POS - Quasi Cash"));

	$dt = &$ckapi['params_post']['dt'] ;
	$fields = array('id','control','splan_id','name','oldname','value','minsale','maxsale','minqty','maxqty','minvalue','maxvalue','start','endd','notes','posacc_id') ;
	foreach ($fields as $field) {
		$dt[$field] = isset($dt[$field]) ? $dt[$field] : '' ;
		$t->set_var($field,$dt[$field]);
		}
	$pos_accno = $dt['posacc_id'] ;
	$t->set_var('pos_accno',$pos_accno);
	$posacsl = selectlist('chart','accno',"WHERE link like '%CS:%' or link like '%CS'",$pos_accno,'id','accno','description');
	$t->set_var('pos_acc_option_block', "<OPTION value='0'>".exapi_lang('N/A')."</OPTION>".$posacsl);
	$t->parse('out','report',True);
	}

    }

?>