<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.package.inc.php 0.16.1 2005/12/04 C K Wu

    class package {

//---- Package List SQL Formation

    function package_list_sql() {
	global $ckapi ;

	$pre = $ckapi['params']['pre'] ;
	foreach ($ckapi['params_sql'] as $key => $value)	$$key = $value ;
	$sql =  "SELECT distinct a.* FROM ${pre}service a, ${pre}assembly b " ;
	$sql.=  "WHERE a.id=b.assembly_id $where order by ".$order." ".$sort ;
	return $sql ;
	}

//---- Package Read

    function package_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$id = $ckapi['params_post']['id'] ;

	$result = $adodb->query("SELECT control FROM ${pre}service WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$result = $adodb->query("SELECT * from ${pre}assembly WHERE assembly_id='$id' order by id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['item_id'.$i] = $rs['item_id'] ;
		$dt['qty'.$i] = $rs['qty'] ;
		}
	$dt['package'] = $dt['id'] = $id ;
	return $dt ;
	}

//---- Package Add Initialisation

    function package_add_init() {
	global $ckapi ;

	$ckapi['params_post']['dt']['item_id1'] = $ckapi['params_post']['dt']['qty1'] = "" ;
	}

//---- Package Validation Checks

    function package_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;
	$op = $ckapi['params_post']['op'] ;

	$err=""; $error=exapi_lang("Error") ;
	if ($op<>'edit')	{
		$result = $adodb->query("SELECT distinct * from ${pre}assembly where assembly_id='$dt[package]'");
		if (exapi_dbrc($result)>0)		$err=exapi_lang("Package already exists");
		}
	For ($i=1;isset($dt['item_id'.$i]);$i++) {
		$row = exapi_lang("Row") ;  $rowi = "[$row $i]" ;
		if ($dt['item_id'.$i]==$dt['package'])	$err=$rowi.exapi_lang("Package cannot be inside itself");
		if (!$dt['qty'.$i])			$err=$rowi.exapi_lang("Missing Component Qty");
		if ($dt['qty'.$i] and !is_numeric($dt['qty'.$i]))
							$err=$rowi.exapi_lang("Component Qty must be numeric");
		if ($dt['qty'.$i] and $dt['qty'.$i]<=0)	$err=$rowi.exapi_lang("Component Qty must be +ve");
		For ($j=1;isset($dt['item_id'.$j]);$j++) {
			$rowij = "[$row $i/$j]" ;
			if ($dt['item_id'.$i]==$dt['item_id'.$j] and $i<>$j)
							$err=$rowij.exapi_lang("Duplicative Components");
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Package Header

    function package_header_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$uniwhere = isset($ckapi['params']['uniwhere']) ? $ckapi['params']['uniwhere'] : '' ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_var('lang_ginfo',exapi_lang("General Information"));
	$t->set_var('lang_package',exapi_lang("Package"));
	$t->set_var('lang_number',exapi_lang("Name/Number"));
	$t->set_var('lang_id',exapi_lang("Audit ID").' :');
	$t->set_var('lang_description',exapi_lang("Description"));
	$t->set_var('lang_notes',exapi_lang("Notes"));

	$where = (!$uniwhere) ? " WHERE id='$dt[package]' " : $uniwhere;
	$fields = array('id','control','package','lastpackage','notes') ;
	foreach ($fields as $field)	$dt[$field] = isset($dt[$field]) ? $dt[$field] : '' ;

	$t->set_var('service_sl',selectlist('service','servicenumber',$where,$dt['package'],'id','servicenumber','description','id')) ;
	if ($dt['package']<>$dt['lastpackage']) {
		$result = $adodb->query("SELECT control FROM ${pre}service WHERE id='$dt[package]'");
		$dt['control'] = exapi_dbflds($result,'control');
		}
	$t->set_var('lastpackage',$dt['package']) ;
	$t->set_var('id',$dt['package']) ;
	$dt['id'] = $dt['package'] ;
	$t->set_var('control',$dt['control']) ;
	$t->set_var('notes',$dt['notes']);

	$t->parse('out','report',True);
	}

//---- Write Package Detail

    function package_detail_write() {
	global $ckapi ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['buttons'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$row_ = exapi_lang('Row')." " ;
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	$t->set_var('lang_comp',exapi_lang('Component Part'));
	$t->set_var('lang_compqty',exapi_lang('Qty of Component inside Package'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_newrow',exapi_lang('Add New Row'));
	$item_list = item_selectlist("",'') ;
	if (isset($delete))	$rowno = intval(str_replace($row_,"",$delete));	else	$rowno = '';
	For ($i=1;isset($dt['item_id'.$i]);$i++) {
		if ($i<>$rowno) {
			$item_id	=	$dt['item_id'.$i] ;
			$qty		=	$dt['qty'.$i] ;
			$j = (isset($delete) and $delete<>'' and $i>$rowno) ? $i-1 : $i ;
			$t->set_var('item_fld','item_id'.$j) ;
			$t->set_var('qty_fld','qty'.$j) ;
			$t->set_var('item_sl',str_replace("'$item_id'","'$item_id' selected",$item_list));
			$t->set_var('qty',$qty) ;
			if (isset($posted))	$t->set_var('rowno',"done"); else $t->set_var('rowno',$row_.$j) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)			$i=1 ;
	if ($i==1)					$newrow=True ;
	if ($newrow) {
		$t->set_var('item_fld','item_id'.$i) ;
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('item_sl',$item_list);
		$t->set_var('qty',"") ;
		$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

//---- Package Post Initialisation

    function package_post_init() {
	global $ckapi ;

	if ($ckapi['params_post']['op']=='new')	$ckapi['params_post']['op'] = 'edit' ;
	}

//---- Package Post - PreCommit Routine

    function package_post_precommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;

	$id = $dt['package'] ;
	if ($op<>'new')	$adodb->query("DELETE FROM ${pre}assembly WHERE assembly_id=$id");
	if ($op<>'delete') {
		$sql1 = "INSERT INTO ${pre}assembly (assembly_id,item_id,qty) " ;
		For ($i=1;isset($dt['item_id'.$i]);$i++) {
			$item_id	= $dt['item_id'.$i];
			$qty		= $dt['qty'.$i] ;
			$sql = "$sql1 VALUES ('$id','$item_id','$qty')" ;
			$adodb->query($sql);
			}
		}
	}

    }

?>
