<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.expc.inc.php 0.16.1 2005/12/04 C K Wu

    class expc {

//---- Expc List SQL Formation

    function expc_list_sql() {
	global $ckapi ;

	$pre = $ckapi['params']['pre'] ;
	foreach ($ckapi['params_sql'] as $key => $value)	$$key = $value ;

	$where = str_replace("approved_by=''","(approved_by='' or approved_by is NULL)",$where) ;
	$sql =	"SELECT b.name as staff,c.name as name,description," ;
	$sql.=	"a.qty,a.unit,a.unitamt,a.rate,a.amount,comment,approved_by,a.id " ;
	$sql.=	"FROM ${pre}pynr_trans a, ${pre}employee b, ${pre}pyrcode c " ;
	$sql.=	"WHERE $where and empid=b.id and pyrcodeid=c.id order by $order $sort" ;

	return $sql ;
	}

//---- Expc List Link Adjustement

    function expc_list_adjust() {
	global $ckapi ;

	$t = &$ckapi['objects']['template'] ;
	if ($ckapi['params_list']['dt']['approved_by']=='')
		$t->set_var(array(	'lang_cancel'	=> '',
					'cancel'	=> ''	)) ;
	  else	$t->set_var(array(	'lang_approve'	=> '',
					'lang_reject'	=> '',
					'approve'	=> '',
					'reject'	=> ''	)) ;
	}

//---- Expc Read

    function expc_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$id = $ckapi['params_post']['id'] ;

	$sql =	"SELECT a.empid,salary,period,pyrcodeid as eaid,basis,a.qty,a.unit," ;
	$sql.=	"a.unitamt,a.rate,a.amount,comment,approved_by,a.id,a.control " ;
	$sql.=	"FROM ${pre}pynr_trans a, ${pre}payroll b, ${pre}pyrcode c " ;
	$sql.=	"WHERE a.id='$id' and a.empid=b.empid and pyrcodeid=c.id" ;
	$result = $adodb->query($sql);
	$dt = $result->fetchRow() ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM ${pre}defaults" ;
	$result = $adodb->query($sql);
	switch ($dt['period']) :
		case "mn" :	$dt['daypay'] = $dt['salary']/exapi_dbflds($result,'mndfactor') ;
				$dt['hourpay'] = $dt['salary']/exapi_dbflds($result,'mnhfactor') ;	break ;
		case "sm" :	$dt['daypay'] = $dt['salary']/exapi_dbflds($result,'smdfactor') ;
				$dt['hourpay'] = $dt['salary']/exapi_dbflds($result,'smhfactor') ;	break ;
		case "wk" :	$dt['daypay'] = $dt['salary']/exapi_dbflds($result,'wkdfactor') ;
				$dt['hourpay'] = $dt['salary']/exapi_dbflds($result,'wkhfactor') ;	break ;
		case "dy" :	$dt['daypay'] = $dt['salary'] ;
				$dt['hourpay'] = $dt['salary']/exapi_dbflds($result,'dyhfactor') ;	break ;
		case "hr" :	$dt['daypay'] = $dt['salary'] * exapi_dbflds($result,'dyhfactor') ;
				$dt['hourpay'] = $dt['salary'] ;				break ;
		endswitch ;
	$dt['daypay'] = sprintf("%01.2f",$dt['daypay']) ;
	$dt['hourpay'] = sprintf("%01.2f",$dt['hourpay']) ;
	return $dt ;
	}

//---- Expc Validation Checks

    function expc_validate() {
	global $ckapi ;

	$dt = $ckapi['params_post']['dt'] ;
	$err="";
	$error = exapi_lang("Error") ;
	if ($dt['reason']=="")	$err=exapi_lang("Cancel/Reject Reason Missing") ;

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Expc Detail

    function expc_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_var('lang_empid',exapi_lang('Employee Name/#'));
	$t->set_var('lang_id',exapi_lang('ID#'));
	$t->set_var('lang_salary',exapi_lang('Basic Salary'));
	$t->set_var('lang_period',exapi_lang('Pay Period'));
	$t->set_var('lang_daypay',exapi_lang('Imputed Daily Pay'));
	$t->set_var('lang_hourpay',exapi_lang('Imputed Hourly Pay'));
	$t->set_var('lang_eaid',exapi_lang('Expense/Allowance Type'));
	$t->set_var('lang_basis',exapi_lang('Basis of Calculation'));
	$t->set_var('lang_qty',exapi_lang('Quantity'));
	$t->set_var('lang_unit',exapi_lang('Unit'));
	$t->set_var('lang_unitamt',exapi_lang('Unit Amount'));
	$t->set_var('lang_rate',exapi_lang('Pay Rate'));
	$t->set_var('lang_amount',exapi_lang('Amount'));
	$t->set_var('lang_comment',exapi_lang('Comment'));
	$t->set_var('lang_approved_by',exapi_lang('Approved By'));
	$user = $ckapi['hostsys']['username'];

	$empid = $dt['empid'] ;
	$sql = "SELECT * FROM ${pre}employee a, ${pre}employee b " ;
	$sql.= "WHERE a.id='$empid' and a.supervisor=b.id and b.contactid='$_GET[contactid]'";
	$result = $adodb->query($sql);
	if (exapi_dbrc($result)==0)	die(exapi_lang("You are not authorised to access the requested information.")) ;
	$where = " WHERE id='$dt[empid]' " ;
	$t->set_var('empid_selectlist',selectlist('employee','name',$where,'','id','name','id')) ;
	$t->set_var('id',$dt['id']);
	$t->set_var('control',$dt['control']);
	$t->set_var('salary',$dt['salary']);
	$t->set_var('period',$dt['period']) ;
	$t->set_var('daypay',$dt['daypay']);
	$t->set_var('hourpay',$dt['hourpay']) ;
	
	$eaid = ($dt['eaid']=="") ? 0 : $dt['eaid'] ;
	$t->set_var('eaid_selectlist',selectlist('pyrcode','name','',$eaid,'id','description')) ;
	if (is_array($ckapi['params']['uniqueflds']))
	  	foreach ($ckapi['params']['uniqueflds'] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var("lasteaid",$eaid);

	$qty = 1 ;
	$result = $adodb->query("SELECT * from ${pre}pyrcode where id='$eaid'");
	$basis		=	exapi_dbflds($result,'basis') ;
	$unit		=	exapi_dbflds($result,'unit') ;
	$unitamt	=	(substr_count($basis,'pc')>0) ? exapi_dbflds($result,'unitamt') : 1 ;
	$rate		=	exapi_dbflds($result,'rate') ;
	$dt['chart_id']	=	exapi_dbflds($result,'chart_id') ;
	if (substr_count($basis,'qty')>0)	{$qty = $dt['qty']; $t->set_var('qty_readonly','');}
		else				$t->set_var('qty_readonly','readonly') ;
	if (substr_count($basis,'bs')>0)	$unitamt = $dt['salary'] ;
	if (substr_count($basis,'hp')>0)	$unitamt = $dt['hourpay'] ;
	if (substr_count($basis,'dp')>0)	$unitamt = $dt['daypay'] ;
	$amount = sprintf("%01.2f",$qty*$unitamt*$rate) ;
	if (substr_count($basis,'amt')>0)	{$amount=$dt['amount']; $t->set_var('amt_readonly','');}
		else				$t->set_var('amt_readonly','readonly') ;
	$dt['qty'] = $qty ;
	$dt['unit'] = $unit ;
	$dt['unitamt'] = $unitamt ;
	$dt['amount'] = $amount ;
	$t->set_var('basis',$basis);
	$t->set_var('qty',$qty);
	$t->set_var('unit',$unit);
	$t->set_var('unitamt',$unitamt);
	$t->set_var('rate',$rate);
	$t->set_var('amount',$amount);
	$t->set_var('comment',$dt['comment']);
	$t->set_var('approved_by',$dt['approved_by']);
	$dt['reason'] = isset($dt['reason']) ? $dt['reason'] : '' ;
	$t->set_var('reason',$dt['reason']);
	$t->parse('out','report',True);
	}

//---- Expc Post Initialisation

    function expc_post_init() {
	global $ckapi ;

	$ckapi['params_post']['dt']['approved_by'] = "" ;
	}

//---- Expc Post - PostCommit Routine

    function expc_post_postcommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;
	$lang_tran = $ckapi['phrases']['lang_tran'] ;
	$actioned = $ckapi['phrases']['actioned'] ;

	$lang_approval = exapi_lang("Approval") ;
	$lang_reason = exapi_lang("Reason") ;
	$inform = exapi_lang("Please manually inform") ;

	$id = $dt['id'] ;
	$empid = $dt['empid'] ;
	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername,a.contactid as empcontactid,b.contactid as supercontactid ";
	$sql.= "FROM ${pre}employee a, ${pre}employee b WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$result = $adodb->query($sql);
	$staffname = exapi_dbflds($result,'staffname');
	$superid = exapi_dbflds($result,'superid');
	$supername = exapi_dbflds($result,'supername');
	$empcontactid = exapi_dbflds($result,'empcontactid');
	$supercontactid = exapi_dbflds($result,'supercontactid');
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$empcontactid' and commcode='wemail'";
	$result = $adodb->query($sql);
	$staffemail = exapi_dbflds($result,'commdata') ;
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$supercontactid' and commcode='wemail'";
	$result = $adodb->query($sql);
	$superemail = exapi_dbflds($result,'commdata') ;
	$recipient = "$staffname < $staffemail >" ;

	$message = '' ;
	$headers = "From: $supername < $superemail >\n" ;
	$charset = exapi_lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $supername < $superemail >\n" ;

	switch ($op) :
	    case "approve" :
		$subject = "[$staffname] $lang_tran [id#$id] $actioned." ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = exapi_lang("Email approving expense/allowance claim successfully queued for despatch to") ;
		$failuremsg = exapi_lang("Email approving expense/allowance claim fails to deliver.")."  $inform" ;
		break ;
	    case "cancel" :
		$subject = "[$staffname] $lang_tran [id#$id] " ;
		$subject.= "$lang_approval $actioned.  $lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg =exapi_lang("Email advising approval cancellation successfully queued for despatch to");
		$failuremsg =exapi_lang("Email advising approval cancellation fails to deliver.")."  $inform" ;
		break ;
	    case "reject" :
		$subject = "[$staffname] $lang_tran [id#$id] $actioned.  " ;
		$subject.= "$lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = exapi_lang("Email rejecting expense/allowance claim successfully queued for despatch to") ;
		$failuremsg = exapi_lang("Email rejecting expense/allowance claim fails to deliver.")."  $inform" ;
		break ;
	    endswitch ;

	if ($result)	$msg = "<br>$successmsg $staffname." ;
		else	$msg = "<br>$failuremsg $staffname." ;
	$ckapi['phrases']["reminder"] = $msg ;
	}

    }

?>