<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.leaveapp.inc.php 0.16.1 2005/12/04 C K Wu

    class leaveapp {

//---- Leave Application List SQL Formation

    function leaveapp_list_sql() {
	global $ckapi ;

	$pre = $ckapi['params']['pre'] ;
	foreach ($ckapi['params_sql'] as $key => $value)	$$key = $value ;

	$lang_leave = exapi_lang('leave') ;
	$user = $ckapi['hostsys']['username'];
	$sql =  "SELECT b.name as staff,a.*,description " ;
	$sql.=  "FROM ${pre}leaveapp a, ${pre}employee b, ${pre}category c " ;
	$sql.=  "WHERE contactid=$_GET[contactid] and empid=b.id and leavecode=c.name and app='ck-hr' and c.type='$lang_leave' $where " ;
	$sql.=	"order by $order $sort" ;
	return $sql ;
	}

//---- Leave Application List Link Adjustement

    function leaveapp_list_adjust() {
	global $ckapi ;

	$t = &$ckapi['objects']['template'] ;
	if ($ckapi['params_list']['dt']['approved_by']<>'')
		$t->set_var(array(	'lang_edit'	=> '',
					'lang_delete'	=> '',
					'edit'		=> '',
					'delete'	=> ''	)) ;
	}

//---- Leave Application Read

    function leaveapp_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$id = $ckapi['params_post']['id'] ;

	$result = $adodb->query("select * from ${pre}leaveapp WHERE id='$id'");
	return $result->fetchRow() ;
	}

//---- Leave Application Add Initialisation

    function leaveapp_add_init() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$result = $adodb->query("SELECT id FROM ${pre}employee WHERE contactid='$_GET[contactid]'");
	$ckapi['params_post']['dt']['empid'] = exapi_dbflds($result,'id');
	}


//---- Leave Application Detail Validation Checks

    function leaveapp_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error = exapi_lang("Error") ;
	$leavefrom = $dt['leavefrom'] ;
	$leaveto = $dt['leaveto'] ;
	if (input2date($leavefrom)=="")		$err=exapi_lang("Invalid From Date");
	if (input2date($leaveto)=="")		$err=exapi_lang("Invalid To Date");
	$from = strtotime($leavefrom) ;
	$to = strtotime($leaveto) ;
	if ($from<mktime(0,0,0))		$err=exapi_lang("Leave application cannot be retrospective") ;
	if ($leavefrom<>"" and $leaveto<>"" and $from>$to)	$err=exapi_lang("From Date later than To Date") ;
	$duration = $dt['duration'] ;
	if (!is_numeric($duration) or $duration=='' or $duration==0)
						$err=exapi_lang("invalid Workdays figure") ;
	if ($duration*10%5 <>0)			$err=exapi_lang("Workdays must be whole day or half a day") ;
	if ($leavefrom<>"" and $leaveto<>"" and ($to-$from)<(($duration-1)*24*60*60))
						$err=exapi_lang("Work Days > Leave Period duration") ;
	if (substr($leavefrom,0,4)<>substr($leaveto,0,4))
						$err=exapi_lang("Leave From year must equal Leave To year") ;
	$dt['id'] = ($dt['id']=="") ? 0 : $dt['id'] ;
	$sql =	"SELECT * FROM ${pre}leaveapp WHERE ((leavefrom>='$leavefrom' and leavefrom<='$leaveto') " ;
	$sql.=	"or(leaveto>='$leavefrom' and leaveto<='$leaveto')) and empid='$dt[empid]' and id<>'$dt[id]'";
	$result = $adodb->query($sql);
	if (exapi_dbrc($result)>0)		$err=exapi_lang("This application overlaps with existing leave applications");
	$sql =	"SELECT * FROM ${pre}leaveapp WHERE (('$leavefrom'>=leavefrom and '$leavefrom'<=leaveto) " ;
	$sql.=	"or('$leaveto'>=leavefrom and '$leaveto'<=leaveto)) and empid='$dt[empid]' and id<>'$dt[id]'";
	$result = $adodb->query($sql);
	if (exapi_dbrc($result)>0)		$err=exapi_lang("This application overlaps with existing leave applications");

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Leave Application Detail

    function leaveapp_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_var('lang_empid',exapi_lang('Employee Name/#'));
	$t->set_var('lang_id',exapi_lang('ID#'));
	$t->set_var('lang_leavefrom',exapi_lang('Leave From'));
	$t->set_var('lang_leaveto',exapi_lang('Leave To'));
	$t->set_var('lang_duration',exapi_lang('Duration in Workdays'));
	$t->set_var('lang_leavecode',exapi_lang('Leave Code -- Description'));
	$t->set_var('lang_approved_by',exapi_lang('Approved By'));
	$lang_leave = exapi_lang('leave') ;
	$empid = $dt['empid'] ;
	$result = $adodb->query("SELECT * FROM ${pre}employee WHERE id='$empid' and contactid='$_GET[contactid]'");
	if (exapi_dbrc($result)==0)	die("$empid..$_GET[contactid]".exapi_lang("You are not authorised to access the requested information.")) ;
	$where = " WHERE id='$dt[empid]' " ;

	$fields = array('empid','staff','id','control','leavefrom','leaveto','duration','leavecode','approved_by') ;
	foreach ($fields as $field)	$dt[$field] = isset($dt[$field]) ? $dt[$field] : '' ;
	$t->set_var('empid_selectlist',selectlist('employee','name',$where,'','id','name','id')) ;
	$t->set_var('staff',$dt['staff']);
	$t->set_var('id',$dt['id']);
	$t->set_var('control',$dt['control']);
	$t->set_var('leavefrom',$dt['leavefrom']);
	$t->set_var('leaveto',$dt['leaveto']);
	$t->set_var('duration',$dt['duration']);
	$where = "WHERE app='ck-hr' and type='$lang_leave' and name<>'SL' and name<>'UA'" ;
	$leavecode_sl = selectlist('category','name',$where,$dt['leavecode'],'name','name','substring(description,1,25)');
	$t->set_var('leavecode_selectlist',$leavecode_sl);
	$t->set_var('approved_by',$dt['approved_by']);
	$t->parse('out','report',True);
	}

//---- Leave Application Post Initialisation

    function leaveapp_post_init() {
	global $ckapi ;

	$ckapi['params_post']['dt']['approved_by'] = "" ;
	}

//---- Leave Application Post - PostCommit Routine

    function leaveapp_post_postcommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;
	$lang_tran = $ckapi['phrases']['lang_tran'] ;
	$actioned = $ckapi['phrases']['actioned'] ;

	$lang_from = exapi_lang("FROM") ;
	$lang_to = exapi_lang("TO") ;
	$inform = exapi_lang("Please manually inform") ;
	$leavefrom = $dt['leavefrom'] ;
	$leaveto = $dt['leaveto'] ;

	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername,b.contactid as supercontactid  ";
	$sql.= "FROM ${pre}employee a, ${pre}employee b WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$result = $adodb->query($sql);
	$staffname = exapi_dbflds($result,'staffname');
	$superid = exapi_dbflds($result,'superid');
	$supername = exapi_dbflds($result,'supername');
	$supercontactid = exapi_dbflds($result,'supercontactid');
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$_GET[contactid]' and commcode='wemail'";
	$result = $adodb->query($sql);
	$staffemail = exapi_dbflds($result,'commdata') ;
	$sql = "SELECT commdata FROM ${pre}comm WHERE contactid='$supercontactid' and commcode='wemail'";
	$result = $adodb->query($sql);
	$superemail = exapi_dbflds($result,'commdata') ;
	$recipient = "$supername < $superemail >" ;
	$subject = "[$staffname] $lang_tran [$lang_from:$leavefrom $lang_to:$leaveto] $actioned." ;
	if ($op<>'delete')   $subject.=' => '.exapi_lang('Please approve');
	$message = '' ;
	$headers = "From: $staffname < $staffemail >\n" ;
	$charset = exapi_lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $staffname < $staffemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	if ($op=='delete') {
		$successmsg = exapi_lang("Email advising action on leave application successfully queued for despatch to") ;
		$failuremsg=exapi_lang("Email advising action on leave application fails to deliver.")."  $inform";
		}
	  else  {
		$successmsg = exapi_lang("Email requesting leave application approval successfully queued for despatch to") ;
		$failuremsg=exapi_lang("Email requesting leave application approval fails to deliver.")."  $inform";
		}
	if ($result)	$msg = "<br>$successmsg $supername." ;
		else	$msg = "<br>$failuremsg $supername." ;
	$ckapi['phrases']["reminder"] = $msg ;
	}


    }

?>